import{S as S2,i as I2,s as N2,e as n,k as h,w as v,t as s,M as M2,c as p,d as r,m as g,a as i,x as b,h as o,b as A,G as e,g as $,y as w,q as j,o as y,B as k,v as U2,L as O}from"../../chunks/vendor-hf-doc-builder.js";import{T as We}from"../../chunks/Tip-hf-doc-builder.js";import{D as T}from"../../chunks/Docstring-hf-doc-builder.js";import{C as D}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as B}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as z}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function R2(E){let c,u;return{c(){c=n("p"),u=s("Step three is optional, but considered a best practice.")},l(m){c=p(m,"P",{});var l=i(c);u=o(l,"Step three is optional, but considered a best practice."),l.forEach(r)},m(m,l){$(m,c,l),e(c,u)},d(m){m&&r(c)}}}function G2(E){let c,u;return{c(){c=n("p"),u=s("Step five is mandatory when using distributed evaluation")},l(m){c=p(m,"P",{});var l=i(c);u=o(l,"Step five is mandatory when using distributed evaluation"),l.forEach(r)},m(m,l){$(m,c,l),e(c,u)},d(m){m&&r(c)}}}function V2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

with accelerator.accumulate():
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.accumulate():
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        scheduler.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function W2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(mixed_precision="fp16")
with accelerator.autocast():
    train()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.autocast():
<span class="hljs-meta">... </span>    train()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function F2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=1)
outputs = model(inputs)
loss = loss_fn(outputs, labels)
accelerator.backward(loss)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">1</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = loss_fn(outputs, labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function H2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, scheduler = ...
model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
accelerator.free_memory()
del model, optimizer, scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.free_memory()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">del</span> model, optimizer, scheduler`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Y2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for input, target in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, target <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function B2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for input, target in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_value_(model.parameters(), clip_value)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, target <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_value_(model.parameters(), clip_value)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function J2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers("my_project")
# Do training
accelerator.end_training()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Do training</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.end_training()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function K2(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, scheduler = ...
model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
accelerator.free_memory()
del model, optimizer, scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.free_memory()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">del</span> model, optimizer, scheduler`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Q2(E){let c,u,m,l,f;return l=new D({props:{code:`# Assuming four processes
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.tensor([accelerator.process_index])
gathered_tensor = accelerator.gather(process_tensor)
gathered_tensor`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming four processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.tensor([accelerator.process_index])
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_tensor = accelerator.gather(process_tensor)
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_tensor
tensor([<span class="hljs-number">0</span>, <span class="hljs-number">1</span>, <span class="hljs-number">2</span>, <span class="hljs-number">3</span>])`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function X2(E){let c,u,m,l,f;return l=new D({props:{code:`# Assuming two processes, with a batch size of 5 on a dataset with 9 samples
import torch
from accelerate import Accelerator

accelerator = Accelerator()
dataloader = torch.utils.data.DataLoader(range(9), batch_size=5)
dataloader = accelerator.prepare(dataloader)
batch = next(iter(dataloader))
gathered_items = accelerator.gather_for_metrics(batch)
len(gathered_items)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes, with a batch size of 5 on a dataset with 9 samples</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader = torch.utils.data.DataLoader(<span class="hljs-built_in">range</span>(<span class="hljs-number">9</span>), batch_size=<span class="hljs-number">5</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader = accelerator.prepare(dataloader)
<span class="hljs-meta">&gt;&gt;&gt; </span>batch = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_items = accelerator.gather_for_metrics(batch)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">len</span>(gathered_items)
<span class="hljs-number">9</span>`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Z2(E){let c,u,m,l,f;return l=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
net = torch.nn.Linear(2, 2)
net = accelerator.prepare(net)
state_dict = accelerator.get_state_dict(net)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>net = torch.nn.Linear(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>net = accelerator.prepare(net)
<span class="hljs-meta">&gt;&gt;&gt; </span>state_dict = accelerator.get_state_dict(net)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function ew(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers("my_project")
tensorboard_tracker = accelerator.get_tracker("tensorboard")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tensorboard_tracker = accelerator.get_tracker(<span class="hljs-string">&quot;tensorboard&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function tw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers(
    project_name="my_project",
    config={"learning_rate": 0.001, "batch_size": 32},
    init_kwargs={"tensorboard": {"flush_secs": 60}},
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(
<span class="hljs-meta">... </span>    project_name=<span class="hljs-string">&quot;my_project&quot;</span>,
<span class="hljs-meta">... </span>    config={<span class="hljs-string">&quot;learning_rate&quot;</span>: <span class="hljs-number">0.001</span>, <span class="hljs-string">&quot;batch_size&quot;</span>: <span class="hljs-number">32</span>},
<span class="hljs-meta">... </span>    init_kwargs={<span class="hljs-string">&quot;tensorboard&quot;</span>: {<span class="hljs-string">&quot;flush_secs&quot;</span>: <span class="hljs-number">60</span>}},
<span class="hljs-meta">... </span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function aw(E){let c,u,m,l;return{c(){c=n("p"),u=n("code"),m=s("join_uneven_inputs"),l=s(` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`)},l(f){c=p(f,"P",{});var t=i(c);u=p(t,"CODE",{});var d=i(u);m=o(d,"join_uneven_inputs"),d.forEach(r),l=o(t,` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`),t.forEach(r)},m(f,t){$(f,c,t),e(c,u),e(u,m),e(c,l)},d(f){f&&r(c)}}}function rw(E){let c,u,m,l,f;return{c(){c=n("p"),u=s("Overidding "),m=n("code"),l=s("even_batches"),f=s(" will not affect iterable-style data loaders.")},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Overidding "),m=p(d,"CODE",{});var q=i(m);l=o(q,"even_batches"),q.forEach(r),f=o(d," will not affect iterable-style data loaders."),d.forEach(r)},m(t,d){$(t,c,d),e(c,u),e(c,m),e(m,l),e(c,f)},d(t){t&&r(c)}}}function sw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(even_batches=True)
ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

with accelerator.join_uneven_inputs([ddp_model], even_batches=False):
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(even_batches=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.join_uneven_inputs([ddp_model], even_batches=<span class="hljs-literal">False</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function ow(E){let c,u,m,l,f;return{c(){c=n("p"),u=s("Should only be used in conjunction with "),m=n("a"),l=s("Accelerator.save_state()"),f=s("."),this.h()},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Should only be used in conjunction with "),m=p(d,"A",{href:!0});var q=i(m);l=o(q,"Accelerator.save_state()"),q.forEach(r),f=o(d,"."),d.forEach(r),this.h()},h(){A(m,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state")},m(t,d){$(t,c,d),e(c,u),e(c,m),e(m,l),e(c,f)},d(t){t&&r(c)}}}function cw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, lr_scheduler = ...
model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
accelerator.load_state("my_checkpoint")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.load_state(<span class="hljs-string">&quot;my_checkpoint&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function lw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.local_main_process_first():
    # This will be printed first by local process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.local_process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.local_main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by local process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.local_process_index}</span>&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function nw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers("my_project")
accelerator.log({"loss": 0.5, "accuracy": 0.9})`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.log({<span class="hljs-string">&quot;loss&quot;</span>: <span class="hljs-number">0.5</span>, <span class="hljs-string">&quot;accuracy&quot;</span>: <span class="hljs-number">0.9</span>})`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function pw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.main_process_first():
    # This will be printed first by process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function iw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
input_a = next(iter(dataloader))
input_b = next(iter(dataloader))

with accelerator.no_sync():
    outputs = model(input_a)
    loss = loss_func(outputs)
    accelerator.backward(loss)
    # No synchronization across processes, only accumulate gradients
outputs = model(input_b)
accelerator.backward(loss)
# Synchronization across all processes
optimizer.step()
optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_a = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>input_b = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.no_sync():
<span class="hljs-meta">... </span>    outputs = model(input_a)
<span class="hljs-meta">... </span>    loss = loss_func(outputs)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-comment"># No synchronization across processes, only accumulate gradients</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_b)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Synchronization across all processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.step()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.zero_grad()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function dw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assume we have 4 processes.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_last_process
def print_something():
    print(f"Printed on process {accelerator.process_index}")


print_something()
"Printed on process 3"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_last_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 3&quot;</span>`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function mw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_local_main_process
def print_something():
    print("This will be printed by process 0 only on each server.")


print_something()
# On server 1:
"This will be printed by process 0 only"
# On server 2:
"This will be printed by process 0 only"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only on each server.&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function hw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_local_process(local_process_index=2)
def print_something():
    print(f"Printed on process {accelerator.local_process_index}")


print_something()
# On server 1:
"Printed on process 2"
# On server 2:
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.local_process_index}</span>&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function gw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_main_process
def print_something():
    print("This will be printed by process 0 only.")


print_something()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()


<span class="hljs-meta">&gt;&gt;&gt; </span>@accelerator.on_main_process
<span class="hljs-meta">... </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only.&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>print_something()
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function fw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assume we have 4 processes.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_process(process_index=2)
def print_something():
    print(f"Printed on process {accelerator.process_index}")


print_something()
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_process(<span class="hljs-params">process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function uw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assuming two processes, with the first processes having a tensor of size 1 and the second of size 2
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.arange(accelerator.process_index + 1).to(accelerator.device)
padded_tensor = accelerator.pad_across_processes(process_tensor)
padded_tensor.shape`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes, with the first processes having a tensor of size 1 and the second of size 2</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.arange(accelerator.process_index + <span class="hljs-number">1</span>).to(accelerator.device)
<span class="hljs-meta">&gt;&gt;&gt; </span>padded_tensor = accelerator.pad_across_processes(process_tensor)
<span class="hljs-meta">&gt;&gt;&gt; </span>padded_tensor.shape
torch.Size([<span class="hljs-number">2</span>])`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function _w(E){let c,u;return{c(){c=n("p"),u=s("You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision")},l(m){c=p(m,"P",{});var l=i(c);u=o(l,"You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision"),l.forEach(r)},m(m,l){$(m,c,l),e(c,u)},d(m){m&&r(c)}}}function $w(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
# Assume a model, optimizer, data_loader and scheduler are defined
model, optimizer, data_loader, scheduler = accelerator.prepare(model, optimizer, data_loader, scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume a model, optimizer, data_loader and scheduler are defined</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, data_loader, scheduler = accelerator.prepare(model, optimizer, data_loader, scheduler)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function vw(E){let c,u,m,l,f;return l=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
data_loader = torch.utils.data.DataLoader(...)
data_loader = accelerator.prepare_data_loader(data_loader, device_placement=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>data_loader = torch.utils.data.DataLoader(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>data_loader = accelerator.prepare_data_loader(data_loader, device_placement=<span class="hljs-literal">True</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function bw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
# Assume a model is defined
model = accelerator.prepare_model(model)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume a model is defined</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.prepare_model(model)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function ww(E){let c,u,m,l,f;return l=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
optimizer = torch.optim.Adam(...)
optimizer = accelerator.prepare_optimizer(optimizer, device_placement=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = torch.optim.Adam(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = accelerator.prepare_optimizer(optimizer, device_placement=<span class="hljs-literal">True</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function jw(E){let c,u,m,l,f;return l=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
optimizer = torch.optim.Adam(...)
scheduler = torch.optim.lr_scheduler.LambdaLR(optimizer, ...)
scheduler = accelerator.prepare_scheduler(scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = torch.optim.Adam(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = torch.optim.lr_scheduler.LambdaLR(optimizer, ...)
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = accelerator.prepare_scheduler(scheduler)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function yw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
accelerator.print("Hello world!")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Hello world!&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function kw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assuming two processes
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.arange(accelerator.num_processes) + 1 + (2 * accelerator.process_index)
process_tensor = process_tensor.to(accelerator.device)
reduced_tensor = accelerator.reduce(process_tensor, reduction="sum")
reduced_tensor`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.arange(accelerator.num_processes) + <span class="hljs-number">1</span> + (<span class="hljs-number">2</span> * accelerator.process_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = process_tensor.to(accelerator.device)
<span class="hljs-meta">&gt;&gt;&gt; </span>reduced_tensor = accelerator.reduce(process_tensor, reduction=<span class="hljs-string">&quot;sum&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>reduced_tensor
tensor([<span class="hljs-number">4</span>, <span class="hljs-number">6</span>])`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Aw(E){let c,u,m,l,f,t,d,q,Fe,$t,J;return{c(){c=n("p"),u=s("Every "),m=n("code"),l=s("object"),f=s(" must have a "),t=n("code"),d=s("load_state_dict"),q=s(" and "),Fe=n("code"),$t=s("state_dict"),J=s(" function to be stored.")},l(He){c=p(He,"P",{});var I=i(c);u=o(I,"Every "),m=p(I,"CODE",{});var ao=i(m);l=o(ao,"object"),ao.forEach(r),f=o(I," must have a "),t=p(I,"CODE",{});var ro=i(t);d=o(ro,"load_state_dict"),ro.forEach(r),q=o(I," and "),Fe=p(I,"CODE",{});var pr=i(Fe);$t=o(pr,"state_dict"),pr.forEach(r),J=o(I," function to be stored."),I.forEach(r)},m(He,I){$(He,c,I),e(c,u),e(c,m),e(m,l),e(c,f),e(c,t),e(t,d),e(c,q),e(c,Fe),e(Fe,$t),e(c,J)},d(He){He&&r(c)}}}function Ew(E){let c,u,m,l,f;return l=new D({props:{code:'from accelerate import Accelerator\n\naccelerator = Accelerator()\n# Assume `CustomObject` has a `state_dict` and `load_state_dict` function.\nobj = CustomObject()\naccelerator.register_for_checkpointing(obj)\naccelerator.save_state("checkpoint.pt")',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator\n\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()\n<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume `CustomObject` has a `state_dict` and `load_state_dict` function.</span>\n<span class="hljs-meta">&gt;&gt;&gt; </span>obj = CustomObject()\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.register_for_checkpointing(obj)\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save_state(<span class="hljs-string">&quot;checkpoint.pt&quot;</span>)'}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function xw(E){let c,u,m,l,f;return{c(){c=n("p"),u=s("Should only be used in conjunction with "),m=n("a"),l=s("Accelerator.register_save_state_pre_hook()"),f=s(`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),this.h()},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Should only be used in conjunction with "),m=p(d,"A",{href:!0});var q=i(m);l=o(q,"Accelerator.register_save_state_pre_hook()"),q.forEach(r),f=o(d,`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),d.forEach(r),this.h()},h(){A(m,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.register_save_state_pre_hook")},m(t,d){$(t,c,d),e(c,u),e(c,m),e(m,l),e(c,f)},d(t){t&&r(c)}}}function Pw(E){let c,u,m,l,f;return{c(){c=n("p"),u=s("Should only be used in conjunction with "),m=n("a"),l=s("Accelerator.register_load_state_pre_hook()"),f=s(`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),this.h()},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Should only be used in conjunction with "),m=p(d,"A",{href:!0});var q=i(m);l=o(q,"Accelerator.register_load_state_pre_hook()"),q.forEach(r),f=o(d,`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),d.forEach(r),this.h()},h(){A(m,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.register_load_state_pre_hook")},m(t,d){$(t,c,d),e(c,u),e(c,m),e(m,l),e(c,f)},d(t){t&&r(c)}}}function Dw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
arr = [0, 1, 2, 3]
accelerator.save(arr, "array.pkl")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>arr = [<span class="hljs-number">0</span>, <span class="hljs-number">1</span>, <span class="hljs-number">2</span>, <span class="hljs-number">3</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save(arr, <span class="hljs-string">&quot;array.pkl&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Tw(E){let c,u;return{c(){c=n("p"),u=s(`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`)},l(m){c=p(m,"P",{});var l=i(c);u=o(l,`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`),l.forEach(r)},m(m,l){$(m,c,l),e(c,u)},d(m){m&&r(c)}}}function zw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, lr_scheduler = ...
model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
accelerator.save_state(output_dir="my_checkpoint")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save_state(output_dir=<span class="hljs-string">&quot;my_checkpoint&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Ow(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for input, target in accelerator.skip_first_batches(dataloader, num_batches=2):
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, target <span class="hljs-keyword">in</span> accelerator.skip_first_batches(dataloader, num_batches=<span class="hljs-number">2</span>):
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Cw(E){let c,u,m,l,f;return l=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer = accelerator.prepare(model, optimizer)
outputs = model(inputs)
loss = loss_fn(outputs, labels)
accelerator.backward(loss)
accelerator.unscale_gradients(optimizer=optimizer)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer = accelerator.prepare(model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = loss_fn(outputs, labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.unscale_gradients(optimizer=optimizer)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function qw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assuming two GPU processes
from torch.nn.parallel import DistributedDataParallel
from accelerate import Accelerator

accelerator = Accelerator()
model = accelerator.prepare(MyModel())
print(model.__class__.__name__)

model = accelerator.unwrap_model(model)
print(model.__class__.__name__)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> torch.nn.parallel <span class="hljs-keyword">import</span> DistributedDataParallel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.prepare(MyModel())
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.__class__.__name__)
DistributedDataParallel

<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.unwrap_model(model)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.__class__.__name__)
MyModel`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Lw(E){let c,u,m,l,f;return l=new D({props:{code:`# Assuming two GPU processes
import time
from accelerate import Accelerator

accelerator = Accelerator()
if accelerator.is_main_process:
    time.sleep(2)
else:
    print("I'm waiting for the main process to finish its sleep...")
accelerator.wait_for_everyone()
# Should print on every process at the same time
print("Everyone is here")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> time
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">if</span> accelerator.is_main_process:
<span class="hljs-meta">... </span>    time.sleep(<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">else</span>:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;I&#x27;m waiting for the main process to finish its sleep...&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.wait_for_everyone()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Should print on every process at the same time</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Everyone is here&quot;</span>)`}}),{c(){c=n("p"),u=s("Example:"),m=h(),v(l.$$.fragment)},l(t){c=p(t,"P",{});var d=i(c);u=o(d,"Example:"),d.forEach(r),m=g(t),b(l.$$.fragment,t)},m(t,d){$(t,c,d),e(c,u),$(t,m,d),w(l,t,d),f=!0},p:O,i(t){f||(j(l.$$.fragment,t),f=!0)},o(t){y(l.$$.fragment,t),f=!1},d(t){t&&r(c),t&&r(m),k(l,t)}}}function Sw(E){let c,u,m,l,f,t,d,q,Fe,$t,J,He,I,ao,ro,pr,Ye,vt,mc,ir,rd,hc,sd,Tp,so,od,zp,he,Be,cd,oo,ld,nd,gc,pd,id,dd,dr,md,co,hd,gd,fd,pe,ud,fc,_d,$d,uc,vd,bd,_c,wd,jd,Op,bt,Cp,Je,wt,yd,$c,kd,Ad,vc,Ed,xd,lo,Pd,no,Dd,qp,jt,Lp,yt,Td,bc,zd,Od,Sp,Ke,kt,wc,mr,Cd,jc,qd,Ip,Qe,At,yc,hr,Ld,kc,Sd,Np,Xe,Ac,Id,Nd,po,Md,Ud,Mp,gr,Up,Ze,Et,Ec,fr,Rd,xc,Gd,Rp,et,xt,Pc,ur,Vd,Dc,Wd,Gp,Pt,Fd,Tc,Hd,Yd,Vp,_r,Wp,Dt,Bd,io,Jd,Kd,Fp,$r,Hp,tt,Tt,zc,vr,Qd,Oc,Xd,Yp,zt,Zd,Cc,em,tm,Bp,br,Jp,Ot,am,mo,rm,sm,Kp,wr,Qp,at,Ct,qc,jr,om,Lc,cm,Xp,ho,lm,Zp,yr,ei,kr,ti,rt,qt,Sc,Ar,nm,Ic,pm,ai,Lt,im,go,dm,mm,ri,st,St,Nc,Er,hm,Mc,gm,si,It,fm,fo,um,_m,oi,xr,ci,ge,$m,uo,vm,bm,Uc,wm,jm,li,Pr,ni,ot,Nt,Rc,Dr,ym,Gc,km,pi,Y,Am,Mt,Em,Vc,xm,Pm,Dm,Wc,Tm,zm,Ut,Om,Fc,Cm,qm,Lm,Hc,Sm,ii,ct,Rt,Yc,Tr,Im,Bc,Nm,di,Gt,Mm,_o,Um,Rm,mi,zr,hi,lt,Vt,Jc,Or,Gm,Kc,Vm,gi,x,Cr,Wm,Qc,Fm,Hm,Xc,Zc,Ym,Bm,C,Wt,el,Jm,Km,tl,Qm,Xm,Zm,Ft,al,eh,th,$o,ah,rh,sh,Ht,rl,oh,ch,sl,lh,nh,ph,Yt,ol,ih,dh,cl,mh,hh,gh,Bt,ll,fh,uh,nl,_h,$h,vh,Jt,pl,bh,wh,il,jh,yh,kh,Kt,dl,Ah,Eh,ml,xh,Ph,Dh,Qt,hl,Th,zh,vo,Oh,Ch,qh,Xt,gl,Lh,Sh,fl,Ih,Nh,Mh,Zt,ul,Uh,Rh,_l,Gh,Vh,Wh,fe,qr,Fh,$l,Hh,Yh,ea,Bh,ue,Lr,Jh,vl,Kh,Qh,ta,Xh,K,Sr,Zh,nt,eg,bl,tg,ag,wl,rg,sg,og,Ir,cg,jl,lg,ng,pg,aa,ig,_e,Nr,dg,Mr,mg,yl,hg,gg,fg,ra,ug,$e,Ur,_g,Rr,$g,kl,vg,bg,wg,sa,jg,ve,Gr,yg,Vr,kg,Al,Ag,Eg,xg,oa,Pg,be,Wr,Dg,El,Tg,zg,ca,Og,we,Fr,Cg,xl,qg,Lg,la,Sg,Q,Hr,Ig,Yr,Ng,Pl,Mg,Ug,Rg,Dl,Gg,Vg,na,Wg,je,Br,Fg,Jr,Hg,Tl,Yg,Bg,Jg,pa,Kg,ye,Kr,Qg,Qr,Xg,bo,Zg,ef,tf,ia,af,ke,Xr,rf,ie,sf,zl,of,cf,Ol,lf,nf,Cl,pf,df,mf,da,hf,Ae,Zr,gf,es,ff,ql,uf,_f,$f,ma,vf,W,ts,bf,as,wf,Ll,jf,yf,kf,ha,Af,ga,Ef,fa,xf,X,rs,Pf,Sl,Df,Tf,ua,zf,_a,Of,Z,ss,Cf,Il,qf,Lf,Nl,Sf,If,$a,Nf,Ee,os,Mf,pt,Uf,Ml,Rf,Gf,Ul,Vf,Wf,Ff,va,Hf,ee,cs,Yf,Rl,Bf,Jf,Gl,Kf,Qf,ba,Xf,te,ls,Zf,ns,eu,Vl,tu,au,ru,ps,su,Wl,ou,cu,lu,wa,nu,xe,is,pu,ds,iu,Fl,du,mu,hu,ja,gu,Pe,ms,fu,hs,uu,Hl,_u,$u,vu,ya,bu,De,gs,wu,fs,ju,Yl,yu,ku,Au,ka,Eu,Te,us,xu,_s,Pu,Bl,Du,Tu,zu,Aa,Ou,ze,$s,Cu,vs,qu,Jl,Lu,Su,Iu,Ea,Nu,Oe,bs,Mu,Kl,Uu,Ru,xa,Gu,ae,ws,Vu,js,Wu,Ql,Fu,Hu,Yu,Pa,Bu,Da,Ju,Ce,ys,Ku,ks,Qu,wo,Xu,Zu,e_,Ta,t_,qe,As,a_,Es,r_,jo,s_,o_,c_,za,l_,Le,xs,n_,Ps,p_,yo,i_,d_,m_,Oa,h_,Se,Ds,g_,Ts,f_,ko,u_,__,$_,Ca,v_,Ie,zs,b_,Os,w_,Xl,j_,y_,k_,qa,A_,re,Cs,E_,it,x_,Zl,P_,D_,en,T_,z_,O_,tn,C_,q_,La,L_,F,qs,S_,de,I_,an,N_,M_,rn,U_,R_,sn,G_,V_,W_,on,F_,H_,Sa,Y_,Ia,B_,M,Ls,J_,dt,K_,cn,Q_,X_,Ao,Z_,e$,t$,ln,a$,r$,nn,pn,s$,o$,V,c$,dn,l$,n$,mn,p$,i$,hn,d$,m$,gn,h$,g$,Eo,f$,u$,_$,Na,$$,U,Ss,v$,mt,b$,fn,w$,j$,xo,y$,k$,A$,un,E$,x$,_n,$n,P$,D$,S,T$,vn,z$,O$,bn,C$,q$,wn,L$,S$,jn,I$,N$,yn,M$,U$,kn,R$,G$,Po,V$,W$,F$,Ma,H$,Ne,Is,Y$,Ns,B$,An,J$,K$,Q$,Ua,X$,R,Ms,Z$,En,ev,tv,N,av,xn,rv,sv,Pn,ov,cv,Dn,lv,nv,Tn,pv,iv,zn,dv,mv,On,hv,gv,fv,Us,uv,Cn,_v,$v,vv,Ra,bv,Ga,wv,Me,Rs,jv,ht,yv,qn,kv,Av,Ln,Ev,xv,Pv,Va,Dv,se,Gs,Tv,Sn,zv,Ov,Wa,Cv,Fa,qv,In,Lv,Sv,Iv,Ha,Nv,Nn,Mv,Uv,Rv,Ya,Gv,Ue,Vs,Vv,gt,Wv,Mn,Fv,Hv,Do,Yv,Bv,Jv,Ba,Kv,Re,Ws,Qv,Un,Xv,Zv,Ja,fi;return t=new B({}),ir=new B({}),bt=new We({props:{$$slots:{default:[R2]},$$scope:{ctx:E}}}),jt=new We({props:{warning:!0,$$slots:{default:[G2]},$$scope:{ctx:E}}}),mr=new B({}),hr=new B({}),gr=new D({props:{code:`- print("My thing I want to print!")
+ accelerator.print("My thing I want to print!")`,highlighted:`<span class="hljs-deletion">- print(&quot;My thing I want to print!&quot;)</span>
<span class="hljs-addition">+ accelerator.print(&quot;My thing I want to print!&quot;)</span>`}}),fr=new B({}),ur=new B({}),_r=new D({props:{code:`if accelerator.is_local_main_process:
    do_thing_once_per_server()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_local_main_process:
    do_thing_once_per_server()`}}),$r=new D({props:{code:`@accelerator.on_local_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once_per_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once_per_server()`}}),vr=new B({}),br=new D({props:{code:`if accelerator.is_main_process:
    do_thing_once()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_main_process:
    do_thing_once()`}}),wr=new D({props:{code:`@accelerator.on_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once()`,highlighted:`<span class="hljs-meta">@accelerator.on_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once()`}}),jr=new B({}),yr=new D({props:{code:`@accelerator.on_local_process(local_process_idx=0)
def do_my_thing():
    "Something done on process index 0 on each server"
    do_thing_on_index_zero_on_each_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_idx=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0 on each server&quot;</span>
    do_thing_on_index_zero_on_each_server()`}}),kr=new D({props:{code:`@accelerator.on_process(process_index=0)
def do_my_thing():
    "Something done on process index 0"
    do_thing_on_index_zero()`,highlighted:`<span class="hljs-meta">@accelerator.on_process(<span class="hljs-params">process_index=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0&quot;</span>
    do_thing_on_index_zero()`}}),Ar=new B({}),Er=new B({}),xr=new D({props:{code:`model = MyModel()
model = accelerator.prepare(model)
# Unwrap
model = accelerator.unwrap_model(model)`,highlighted:`model = MyModel()
model = accelerator.prepare(model)
<span class="hljs-comment"># Unwrap</span>
model = accelerator.unwrap_model(model)`}}),Pr=new D({props:{code:`  state_dict = model.state_dict()
- torch.save(state_dict, "my_state.pkl")
+ accelerator.save(state_dict, "my_state.pkl")`,highlighted:`  state_dict = model.state_dict()
<span class="hljs-deletion">- torch.save(state_dict, &quot;my_state.pkl&quot;)</span>
<span class="hljs-addition">+ accelerator.save(state_dict, &quot;my_state.pkl&quot;)</span>`}}),Dr=new B({}),Tr=new B({}),zr=new D({props:{code:`- accelerator = Accelerator()
+ accelerator = Accelerator(gradient_accumulation_steps=2)

  for (input, label) in training_dataloader:
+     with accelerator.accumulate(model):
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`,highlighted:`<span class="hljs-deletion">- accelerator = Accelerator()</span>
<span class="hljs-addition">+ accelerator = Accelerator(gradient_accumulation_steps=2)</span>

  for (input, label) in training_dataloader:
<span class="hljs-addition">+     with accelerator.accumulate(model):</span>
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`}}),Or=new B({}),Cr=new T({props:{name:"class accelerate.Accelerator",anchor:"accelerate.Accelerator",parameters:[{name:"device_placement",val:": bool = True"},{name:"split_batches",val:": bool = False"},{name:"mixed_precision",val:": typing.Union[accelerate.utils.dataclasses.PrecisionType, str] = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"cpu",val:": bool = False"},{name:"deepspeed_plugin",val:": DeepSpeedPlugin = None"},{name:"fsdp_plugin",val:": FullyShardedDataParallelPlugin = None"},{name:"megatron_lm_plugin",val:": MegatronLMPlugin = None"},{name:"rng_types",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.RNGType]], NoneType] = None"},{name:"log_with",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.LoggerType, accelerate.tracking.GeneralTracker]], NoneType] = None"},{name:"project_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"project_config",val:": typing.Optional[accelerate.utils.dataclasses.ProjectConfiguration] = None"},{name:"logging_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"dispatch_batches",val:": typing.Optional[bool] = None"},{name:"even_batches",val:": bool = True"},{name:"step_scheduler_with_optimizer",val:": bool = True"},{name:"kwargs_handlers",val:": typing.Optional[typing.List[accelerate.utils.dataclasses.KwargsHandler]] = None"},{name:"dynamo_backend",val:": typing.Union[accelerate.utils.dataclasses.DynamoBackend, str] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the accelerator should put objects on device (tensors yielded by the dataloader, model,
etc&#x2026;).`,name:"device_placement"},{anchor:"accelerate.Accelerator.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the accelerator should split the batches yielded by the dataloaders across the devices. If
<code>True</code> the actual batch size used will be the same on any kind of distributed processes, but it must be a
round multiple of the <code>num_processes</code> you are using. If <code>False</code>, actual batch size used will be the one set
in your script multiplied by the number of processes.`,name:"split_batches"},{anchor:"accelerate.Accelerator.mixed_precision",description:`<strong>mixed_precision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Whether or not to use mixed precision training (fp16 or bfloat16). Choose from &#x2018;no&#x2019;,&#x2018;fp16&#x2019;,&#x2018;bf16&#x2019;. Will
default to the value in the environment variable <code>ACCELERATE_MIXED_PRECISION</code>, which will use the default
value in the accelerate config of the current system or the flag passed with the <code>accelerate.launch</code>
command. &#x2018;fp16&#x2019; requires pytorch 1.6 or higher. &#x2018;bf16&#x2019; requires pytorch 1.10 or higher.`,name:"mixed_precision"},{anchor:"accelerate.Accelerator.gradient_accumulation_steps",description:`<strong>gradient_accumulation_steps</strong> (<code>int</code>, <em>optional</em>, default to 1) &#x2014;
The number of steps that should pass before gradients are accumulated. A number &gt; 1 should be combined with
<code>Accelerator.accumulate</code>. If not passed, will default to the value in the environment variable
<code>ACCELERATE_GRADIENT_ACCUMULATION_STEPS</code>.`,name:"gradient_accumulation_steps"},{anchor:"accelerate.Accelerator.cpu",description:`<strong>cpu</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to force the script to execute on CPU. Will ignore GPU available if set to <code>True</code> and force
the execution on one process only.`,name:"cpu"},{anchor:"accelerate.Accelerator.deepspeed_plugin",description:`<strong>deepspeed_plugin</strong> (<code>DeepSpeedPlugin</code>, <em>optional</em>) &#x2014;
Tweak your DeepSpeed related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"deepspeed_plugin"},{anchor:"accelerate.Accelerator.fsdp_plugin",description:`<strong>fsdp_plugin</strong> (<code>FullyShardedDataParallelPlugin</code>, <em>optional</em>) &#x2014;
Tweak your FSDP related args using this argument. This argument is optional and can be configured directly
using <em>accelerate config</em>`,name:"fsdp_plugin"},{anchor:"accelerate.Accelerator.megatron_lm_plugin",description:`<strong>megatron_lm_plugin</strong> (<code>MegatronLMPlugin</code>, <em>optional</em>) &#x2014;
Tweak your MegatronLM related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"megatron_lm_plugin"},{anchor:"accelerate.Accelerator.rng_types",description:`<strong>rng_types</strong> (list of <code>str</code> or <code>RNGType</code>) &#x2014;
The list of random number generators to synchronize at the beginning of each iteration in your prepared
dataloaders. Should be one or several of:</p>
<ul>
<li><code>&quot;torch&quot;</code>: the base torch random number generator</li>
<li><code>&quot;cuda&quot;</code>: the CUDA random number generator (GPU only)</li>
<li><code>&quot;xla&quot;</code>: the XLA random number generator (TPU only)</li>
<li><code>&quot;generator&quot;</code>: the <code>torch.Generator</code> of the sampler (or batch sampler if there is no sampler in your
dataloader) or of the iterable dataset (if it exists) if the underlying dataset is of that type.</li>
</ul>
<p>Will default to <code>[&quot;torch&quot;]</code> for PyTorch versions &lt;=1.5.1 and <code>[&quot;generator&quot;]</code> for PyTorch versions &gt;= 1.6.`,name:"rng_types"},{anchor:"accelerate.Accelerator.log_with",description:`<strong>log_with</strong> (list of <code>str</code>, <a href="/docs/accelerate/main/en/package_reference/utilities#accelerate.utils.LoggerType">LoggerType</a> or <a href="/docs/accelerate/main/en/package_reference/tracking#accelerate.tracking.GeneralTracker">GeneralTracker</a>, <em>optional</em>) &#x2014;
A list of loggers to be setup for experiment tracking. Should be one or several of:</p>
<ul>
<li><code>&quot;all&quot;</code></li>
<li><code>&quot;tensorboard&quot;</code></li>
<li><code>&quot;wandb&quot;</code></li>
<li><code>&quot;comet_ml&quot;</code>
If <code>&quot;all&quot;</code> is selected, will pick up all available trackers in the environment and initialize them. Can
also accept implementations of <code>GeneralTracker</code> for custom trackers, and can be combined with <code>&quot;all&quot;</code>.</li>
</ul>`,name:"log_with"},{anchor:"accelerate.Accelerator.project_config",description:`<strong>project_config</strong> (<code>ProjectConfiguration</code>, <em>optional</em>) &#x2014;
A configuration for how saving the state can be handled.`,name:"project_config"},{anchor:"accelerate.Accelerator.project_dir",description:`<strong>project_dir</strong> (<code>str</code>, <code>os.PathLike</code>, <em>optional</em>) &#x2014;
A path to a directory for storing data such as logs of locally-compatible loggers and potentially saved
checkpoints.`,name:"project_dir"},{anchor:"accelerate.Accelerator.dispatch_batches",description:`<strong>dispatch_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, the dataloader prepared by the Accelerator is only iterated through on the main process
and then the batches are split and broadcast to each process. Will default to <code>True</code> for <code>DataLoader</code> whose
underlying dataset is an <code>IterableDataset</code>, <code>False</code> otherwise.`,name:"dispatch_batches"},{anchor:"accelerate.Accelerator.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, in cases where the total batch size across all processes does not exactly divide the
dataset, samples at the start of the dataset will be duplicated so the batch can be divided equally among
all workers.`,name:"even_batches"},{anchor:"accelerate.Accelerator.step_scheduler_with_optimizer",description:"<strong>step_scheduler_with_optimizer</strong> (<code>bool</code>, *optional<code>, defaults to </code>True<code>) -- Set </code>True<code>if the learning rate scheduler is stepped at the same time as the optimizer,</code>False` if only\ndone under certain circumstances (at the end of each epoch, for instance).",name:"step_scheduler_with_optimizer"},{anchor:"accelerate.Accelerator.kwargs_handlers",description:`<strong>kwargs_handlers</strong> (<code>List[KwargHandler]</code>, <em>optional</em>) &#x2014;
A list of <code>KwargHandler</code> to customize how the objects related to distributed training or mixed precision
are created. See <a href="kwargs">kwargs</a> for more information.`,name:"kwargs_handlers"},{anchor:"accelerate.Accelerator.dynamo_backend",description:`<strong>dynamo_backend</strong> (<code>str</code> or <code>DynamoBackend</code>, <em>optional</em>, defaults to <code>&quot;no&quot;</code>) &#x2014;
Set to one of the possible dynamo backends to optimize your training with torch dynamo.`,name:"dynamo_backend"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L112"}}),qr=new T({props:{name:"accumulate",anchor:"accelerate.Accelerator.accumulate",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.accumulate.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L770"}}),ea=new z({props:{anchor:"accelerate.Accelerator.accumulate.example",$$slots:{default:[V2]},$$scope:{ctx:E}}}),Lr=new T({props:{name:"autocast",anchor:"accelerate.Accelerator.autocast",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2435"}}),ta=new z({props:{anchor:"accelerate.Accelerator.autocast.example",$$slots:{default:[W2]},$$scope:{ctx:E}}}),Sr=new T({props:{name:"backward",anchor:"accelerate.Accelerator.backward",parameters:[{name:"loss",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1528"}}),aa=new z({props:{anchor:"accelerate.Accelerator.backward.example",$$slots:{default:[F2]},$$scope:{ctx:E}}}),Nr=new T({props:{name:"clear",anchor:"accelerate.Accelerator.clear",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2303"}}),ra=new z({props:{anchor:"accelerate.Accelerator.clear.example",$$slots:{default:[H2]},$$scope:{ctx:E}}}),Ur=new T({props:{name:"clip_grad_norm_",anchor:"accelerate.Accelerator.clip_grad_norm_",parameters:[{name:"parameters",val:""},{name:"max_norm",val:""},{name:"norm_type",val:" = 2"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1593",returnDescription:`
<p>Total norm of the parameter gradients (viewed as a single vector).</p>
`,returnType:`
<p><code>torch.Tensor</code></p>
`}}),sa=new z({props:{anchor:"accelerate.Accelerator.clip_grad_norm_.example",$$slots:{default:[Y2]},$$scope:{ctx:E}}}),Gr=new T({props:{name:"clip_grad_value_",anchor:"accelerate.Accelerator.clip_grad_value_",parameters:[{name:"parameters",val:""},{name:"clip_value",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1631"}}),oa=new z({props:{anchor:"accelerate.Accelerator.clip_grad_value_.example",$$slots:{default:[B2]},$$scope:{ctx:E}}}),Wr=new T({props:{name:"end_training",anchor:"accelerate.Accelerator.end_training",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1974"}}),ca=new z({props:{anchor:"accelerate.Accelerator.end_training.example",$$slots:{default:[J2]},$$scope:{ctx:E}}}),Fr=new T({props:{name:"free_memory",anchor:"accelerate.Accelerator.free_memory",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2279"}}),la=new z({props:{anchor:"accelerate.Accelerator.free_memory.example",$$slots:{default:[K2]},$$scope:{ctx:E}}}),Hr=new T({props:{name:"gather",anchor:"accelerate.Accelerator.gather",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to gather across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1658",returnDescription:`
<p>The gathered tensor(s). Note that the
first dimension of the result is <em>num_processes</em> multiplied by the first dimension of the input tensors.</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),na=new z({props:{anchor:"accelerate.Accelerator.gather.example",$$slots:{default:[Q2]},$$scope:{ctx:E}}}),Br=new T({props:{name:"gather_for_metrics",anchor:"accelerate.Accelerator.gather_for_metrics",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather_for_metrics.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors for calculating metrics across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1690"}}),pa=new z({props:{anchor:"accelerate.Accelerator.gather_for_metrics.example",$$slots:{default:[X2]},$$scope:{ctx:E}}}),Kr=new T({props:{name:"get_state_dict",anchor:"accelerate.Accelerator.get_state_dict",parameters:[{name:"model",val:""},{name:"unwrap",val:" = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_state_dict.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model sent through <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare">Accelerator.prepare()</a>`,name:"model"},{anchor:"accelerate.Accelerator.get_state_dict.unwrap",description:`<strong>unwrap</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to return the original underlying state_dict of <code>model</code> or to return the wrapped state_dict`,name:"unwrap"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2347",returnDescription:`
<p>The state dictionary of the model potentially without full precision.</p>
`,returnType:`
<p><code>dict</code></p>
`}}),ia=new z({props:{anchor:"accelerate.Accelerator.get_state_dict.example",$$slots:{default:[Z2]},$$scope:{ctx:E}}}),Xr=new T({props:{name:"get_tracker",anchor:"accelerate.Accelerator.get_tracker",parameters:[{name:"name",val:": str"},{name:"unwrap",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_tracker.name",description:`<strong>name</strong> (<code>str</code>) &#x2014;
The name of a tracker, corresponding to the <code>.name</code> property.`,name:"name"},{anchor:"accelerate.Accelerator.get_tracker.unwrap",description:`<strong>unwrap</strong> (<code>bool</code>) &#x2014;
Whether to return the internal tracking mechanism or to return the wrapped tracker instead
(recommended).`,name:"unwrap"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1912",returnDescription:`
<p>The tracker corresponding to <code>name</code> if it exists.</p>
`,returnType:`
<p><code>GeneralTracker</code></p>
`}}),da=new z({props:{anchor:"accelerate.Accelerator.get_tracker.example",$$slots:{default:[ew]},$$scope:{ctx:E}}}),Zr=new T({props:{name:"init_trackers",anchor:"accelerate.Accelerator.init_trackers",parameters:[{name:"project_name",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"init_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.init_trackers.project_name",description:`<strong>project_name</strong> (<code>str</code>) &#x2014;
The name of the project. All trackers will save their data based on this`,name:"project_name"},{anchor:"accelerate.Accelerator.init_trackers.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Optional starting configuration to be logged.`,name:"config"},{anchor:"accelerate.Accelerator.init_trackers.init_kwargs",description:`<strong>init_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>__init__</code> function. Should be
formatted like so:`,name:"init_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1864"}}),ma=new z({props:{anchor:"accelerate.Accelerator.init_trackers.example",$$slots:{default:[tw]},$$scope:{ctx:E}}}),ts=new T({props:{name:"join_uneven_inputs",anchor:"accelerate.Accelerator.join_uneven_inputs",parameters:[{name:"joinables",val:""},{name:"even_batches",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.join_uneven_inputs.joinables",description:`<strong>joinables</strong> (<code>List[torch.distributed.algorithms.Joinable]</code>) &#x2014;
A list of models or optimizers that subclass <code>torch.distributed.algorithms.Joinable</code>. Most commonly, a
PyTorch Module that was prepared with <code>Accelerator.prepare</code> for DistributedDataParallel training.`,name:"joinables"},{anchor:"accelerate.Accelerator.join_uneven_inputs.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set, this will override the value of <code>even_batches</code> set in the <code>Accelerator</code>. If it is not provided,
the default <code>Accelerator</code> value wil be used.`,name:"even_batches"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L806"}}),ha=new We({props:{warning:!0,$$slots:{default:[aw]},$$scope:{ctx:E}}}),ga=new We({props:{warning:!0,$$slots:{default:[rw]},$$scope:{ctx:E}}}),fa=new z({props:{anchor:"accelerate.Accelerator.join_uneven_inputs.example",$$slots:{default:[sw]},$$scope:{ctx:E}}}),rs=new T({props:{name:"load_state",anchor:"accelerate.Accelerator.load_state",parameters:[{name:"input_dir",val:": str"},{name:"**load_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.load_state.input_dir",description:`<strong>input_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder all relevant weights and states were saved in.`,name:"input_dir"},{anchor:"accelerate.Accelerator.load_state.load_model_func_kwargs",description:`<strong>load_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for loading model which can be passed to the underlying load function,
such as optional arguments for DeepSpeed&#x2019;s <code>load_checkpoint</code> function.`,name:"load_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2187"}}),ua=new We({props:{$$slots:{default:[ow]},$$scope:{ctx:E}}}),_a=new z({props:{anchor:"accelerate.Accelerator.load_state.example",$$slots:{default:[cw]},$$scope:{ctx:E}}}),ss=new T({props:{name:"local_main_process_first",anchor:"accelerate.Accelerator.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L695"}}),$a=new z({props:{anchor:"accelerate.Accelerator.local_main_process_first.example",$$slots:{default:[lw]},$$scope:{ctx:E}}}),os=new T({props:{name:"log",anchor:"accelerate.Accelerator.log",parameters:[{name:"values",val:": dict"},{name:"step",val:": typing.Optional[int] = None"},{name:"log_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.log.values",description:`<strong>values</strong> (<code>dict</code>) &#x2014;
Values should be a dictionary-like object containing only types <code>int</code>, <code>float</code>, or <code>str</code>.`,name:"values"},{anchor:"accelerate.Accelerator.log.step",description:`<strong>step</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The run step. If included, the log will be affiliated with this step.`,name:"step"},{anchor:"accelerate.Accelerator.log.log_kwargs",description:`<strong>log_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>log</code> function. Should be formatted
like so:`,name:"log_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1944"}}),va=new z({props:{anchor:"accelerate.Accelerator.log.example",$$slots:{default:[nw]},$$scope:{ctx:E}}}),cs=new T({props:{name:"main_process_first",anchor:"accelerate.Accelerator.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L674"}}),ba=new z({props:{anchor:"accelerate.Accelerator.main_process_first.example",$$slots:{default:[pw]},$$scope:{ctx:E}}}),ls=new T({props:{name:"no_sync",anchor:"accelerate.Accelerator.no_sync",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.no_sync.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L716"}}),wa=new z({props:{anchor:"accelerate.Accelerator.no_sync.example",$$slots:{default:[iw]},$$scope:{ctx:E}}}),is=new T({props:{name:"on_last_process",anchor:"accelerate.Accelerator.on_last_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any]"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_last_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L554"}}),ja=new z({props:{anchor:"accelerate.Accelerator.on_last_process.example",$$slots:{default:[dw]},$$scope:{ctx:E}}}),ms=new T({props:{name:"on_local_main_process",anchor:"accelerate.Accelerator.on_local_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_local_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L516"}}),ya=new z({props:{anchor:"accelerate.Accelerator.on_local_main_process.example",$$slots:{default:[mw]},$$scope:{ctx:E}}}),gs=new T({props:{name:"on_local_process",anchor:"accelerate.Accelerator.on_local_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"local_process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_local_process.function",description:`<strong>function</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.Accelerator.on_local_process.local_process_index",description:`<strong>local_process_index</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The index of the local process on which to run the function.`,name:"local_process_index"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L630"}}),ka=new z({props:{anchor:"accelerate.Accelerator.on_local_process.example",$$slots:{default:[hw]},$$scope:{ctx:E}}}),us=new T({props:{name:"on_main_process",anchor:"accelerate.Accelerator.on_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L481"}}),Aa=new z({props:{anchor:"accelerate.Accelerator.on_main_process.example",$$slots:{default:[gw]},$$scope:{ctx:E}}}),$s=new T({props:{name:"on_process",anchor:"accelerate.Accelerator.on_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.on_process.function",description:`<strong>function</strong> (<code>Callable</code>, <code>optional</code>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.Accelerator.on_process.process_index",description:`<strong>process_index</strong> (<code>int</code>, <code>optional</code>) &#x2014;
The index of the process on which to run the function.`,name:"process_index"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L589"}}),Ea=new z({props:{anchor:"accelerate.Accelerator.on_process.example",$$slots:{default:[fw]},$$scope:{ctx:E}}}),bs=new T({props:{name:"pad_across_processes",anchor:"accelerate.Accelerator.pad_across_processes",parameters:[{name:"tensor",val:""},{name:"dim",val:" = 0"},{name:"pad_index",val:" = 0"},{name:"pad_first",val:" = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.pad_across_processes.tensor",description:`<strong>tensor</strong> (nested list/tuple/dictionary of <code>torch.Tensor</code>) &#x2014;
The data to gather.`,name:"tensor"},{anchor:"accelerate.Accelerator.pad_across_processes.dim",description:`<strong>dim</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The dimension on which to pad.`,name:"dim"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_index",description:`<strong>pad_index</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The value with which to pad.`,name:"pad_index"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_first",description:`<strong>pad_first</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to pad at the beginning or the end.`,name:"pad_first"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1772",returnDescription:`
<p>The padded tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),xa=new z({props:{anchor:"accelerate.Accelerator.pad_across_processes.example",$$slots:{default:[uw]},$$scope:{ctx:E}}}),ws=new T({props:{name:"prepare",anchor:"accelerate.Accelerator.prepare",parameters:[{name:"*args",val:""},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare.*args",description:`<strong>*args</strong> (list of objects) &#x2014;
Any of the following type of objects:</p>
<ul>
<li><code>torch.utils.data.DataLoader</code>: PyTorch Dataloader</li>
<li><code>torch.nn.Module</code>: PyTorch Module</li>
<li><code>torch.optim.Optimizer</code>: PyTorch Optimizer</li>
<li><code>torch.optim.lr_scheduler.LRScheduler</code>: PyTorch LR Scheduler</li>
</ul>`,name:"*args"},{anchor:"accelerate.Accelerator.prepare.device_placement",description:`<strong>device_placement</strong> (<code>List[bool]</code>, <em>optional</em>) &#x2014;
Used to customize whether automatic device placement should be performed for each object passed. Needs
to be a list of the same length as <code>args</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L970"}}),Pa=new We({props:{$$slots:{default:[_w]},$$scope:{ctx:E}}}),Da=new z({props:{anchor:"accelerate.Accelerator.prepare.example",$$slots:{default:[$w]},$$scope:{ctx:E}}}),ys=new T({props:{name:"prepare_data_loader",anchor:"accelerate.Accelerator.prepare_data_loader",parameters:[{name:"data_loader",val:": DataLoader"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_data_loader.data_loader",description:`<strong>data_loader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014;
A vanilla PyTorch DataLoader to prepare`,name:"data_loader"},{anchor:"accelerate.Accelerator.prepare_data_loader.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the batches on the proper device in the prepared dataloader. Will default to
<code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1425"}}),Ta=new z({props:{anchor:"accelerate.Accelerator.prepare_data_loader.example",$$slots:{default:[vw]},$$scope:{ctx:E}}}),As=new T({props:{name:"prepare_model",anchor:"accelerate.Accelerator.prepare_model",parameters:[{name:"model",val:": Module"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model to prepare. You don&#x2019;t need to prepare a model if it is used only for inference without
any kind of mixed precision`,name:"model"},{anchor:"accelerate.Accelerator.prepare_model.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the model on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1078"}}),za=new z({props:{anchor:"accelerate.Accelerator.prepare_model.example",$$slots:{default:[bw]},$$scope:{ctx:E}}}),xs=new T({props:{name:"prepare_optimizer",anchor:"accelerate.Accelerator.prepare_optimizer",parameters:[{name:"optimizer",val:": Optimizer"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_optimizer.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code>) &#x2014;
A vanilla PyTorch optimizer to prepare`,name:"optimizer"},{anchor:"accelerate.Accelerator.prepare_optimizer.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the optimizer on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1464"}}),Oa=new z({props:{anchor:"accelerate.Accelerator.prepare_optimizer.example",$$slots:{default:[ww]},$$scope:{ctx:E}}}),Ds=new T({props:{name:"prepare_scheduler",anchor:"accelerate.Accelerator.prepare_scheduler",parameters:[{name:"scheduler",val:": _LRScheduler"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_scheduler.scheduler",description:`<strong>scheduler</strong> (<code>torch.optim.lr_scheduler.LRScheduler</code>) &#x2014;
A vanilla PyTorch scheduler to prepare`,name:"scheduler"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1492"}}),Ca=new z({props:{anchor:"accelerate.Accelerator.prepare_scheduler.example",$$slots:{default:[jw]},$$scope:{ctx:E}}}),zs=new T({props:{name:"print",anchor:"accelerate.Accelerator.print",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L892"}}),qa=new z({props:{anchor:"accelerate.Accelerator.print.example",$$slots:{default:[yw]},$$scope:{ctx:E}}}),Cs=new T({props:{name:"reduce",anchor:"accelerate.Accelerator.reduce",parameters:[{name:"tensor",val:""},{name:"reduction",val:" = 'sum'"}],parametersDescription:[{anchor:"accelerate.Accelerator.reduce.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to reduce across all processes.`,name:"tensor"},{anchor:"accelerate.Accelerator.reduce.reduction",description:`<strong>reduction</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;sum&#x201D;) &#x2014;
A reduction type, can be one of &#x2018;sum&#x2019;, &#x2018;mean&#x2019;, or &#x2018;none&#x2019;. If &#x2018;none&#x2019;, will not perform any operation.`,name:"reduction"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1738",returnDescription:`
<p>The reduced tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),La=new z({props:{anchor:"accelerate.Accelerator.reduce.example",$$slots:{default:[kw]},$$scope:{ctx:E}}}),qs=new T({props:{name:"register_for_checkpointing",anchor:"accelerate.Accelerator.register_for_checkpointing",parameters:[{name:"*objects",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2399"}}),Sa=new We({props:{$$slots:{default:[Aw]},$$scope:{ctx:E}}}),Ia=new z({props:{anchor:"accelerate.Accelerator.register_for_checkpointing.example",$$slots:{default:[Ew]},$$scope:{ctx:E}}}),Ls=new T({props:{name:"register_load_state_pre_hook",anchor:"accelerate.Accelerator.register_load_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_load_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state">Accelerator.load_state()</a> before <code>load_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2156",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),Na=new We({props:{$$slots:{default:[xw]},$$scope:{ctx:E}}}),Ss=new T({props:{name:"register_save_state_pre_hook",anchor:"accelerate.Accelerator.register_save_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_save_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state">Accelerator.save_state()</a> before <code>save_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2014",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),Ma=new We({props:{$$slots:{default:[Pw]},$$scope:{ctx:E}}}),Is=new T({props:{name:"save",anchor:"accelerate.Accelerator.save",parameters:[{name:"obj",val:""},{name:"f",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save.obj",description:"<strong>obj</strong> (<code>object</code>) &#x2014; The object to save.",name:"obj"},{anchor:"accelerate.Accelerator.save.f",description:"<strong>f</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014; Where to save the content of <code>obj</code>.",name:"f"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1994"}}),Ua=new z({props:{anchor:"accelerate.Accelerator.save.example",$$slots:{default:[Dw]},$$scope:{ctx:E}}}),Ms=new T({props:{name:"save_state",anchor:"accelerate.Accelerator.save_state",parameters:[{name:"output_dir",val:": str = None"},{name:"**save_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save_state.output_dir",description:`<strong>output_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder to save all relevant weights and states.`,name:"output_dir"},{anchor:"accelerate.Accelerator.save_state.save_model_func_kwargs",description:`<strong>save_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for saving model which can be passed to the underlying save function, such
as optional arguments for DeepSpeed&#x2019;s <code>save_checkpoint</code> function.`,name:"save_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2046"}}),Ra=new We({props:{$$slots:{default:[Tw]},$$scope:{ctx:E}}}),Ga=new z({props:{anchor:"accelerate.Accelerator.save_state.example",$$slots:{default:[zw]},$$scope:{ctx:E}}}),Rs=new T({props:{name:"skip_first_batches",anchor:"accelerate.Accelerator.skip_first_batches",parameters:[{name:"dataloader",val:""},{name:"num_batches",val:": int = 0"}],parametersDescription:[{anchor:"accelerate.Accelerator.skip_first_batches.dataloader",description:"<strong>dataloader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014; The data loader in which to skip batches.",name:"dataloader"},{anchor:"accelerate.Accelerator.skip_first_batches.num_batches",description:"<strong>num_batches</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The number of batches to skip",name:"num_batches"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L2477"}}),Va=new z({props:{anchor:"accelerate.Accelerator.skip_first_batches.example",$$slots:{default:[Ow]},$$scope:{ctx:E}}}),Gs=new T({props:{name:"unscale_gradients",anchor:"accelerate.Accelerator.unscale_gradients",parameters:[{name:"optimizer",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.unscale_gradients.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code> or <code>List[torch.optim.Optimizer]</code>, <em>optional</em>) &#x2014;
The optimizer(s) for which to unscale gradients. If not set, will unscale gradients on all optimizers
that were passed to <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>.`,name:"optimizer"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1558"}}),Ya=new z({props:{anchor:"accelerate.Accelerator.unscale_gradients.example",$$slots:{default:[Cw]},$$scope:{ctx:E}}}),Vs=new T({props:{name:"unwrap_model",anchor:"accelerate.Accelerator.unwrap_model",parameters:[{name:"model",val:""},{name:"keep_fp32_wrapper",val:": bool = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.unwrap_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to unwrap.`,name:"model"},{anchor:"accelerate.Accelerator.unwrap_model.keep_fp32_wrapper",description:`<strong>keep_fp32_wrapper</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to not remove the mixed precision hook if it was added.`,name:"keep_fp32_wrapper"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1807",returnDescription:`
<p>The unwrapped model.</p>
`,returnType:`
<p><code>torch.nn.Module</code></p>
`}}),Ba=new z({props:{anchor:"accelerate.Accelerator.unwrap_model.example",$$slots:{default:[qw]},$$scope:{ctx:E}}}),Ws=new T({props:{name:"wait_for_everyone",anchor:"accelerate.Accelerator.wait_for_everyone",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1840"}}),Ja=new z({props:{anchor:"accelerate.Accelerator.wait_for_everyone.example",$$slots:{default:[Lw]},$$scope:{ctx:E}}}),{c(){c=n("meta"),u=h(),m=n("h1"),l=n("a"),f=n("span"),v(t.$$.fragment),d=h(),q=n("span"),Fe=s("Accelerator"),$t=h(),J=n("p"),He=s("The "),I=n("a"),ao=s("Accelerator"),ro=s(` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),pr=h(),Ye=n("h2"),vt=n("a"),mc=n("span"),v(ir.$$.fragment),rd=h(),hc=n("span"),sd=s("Quick adaptation of your code"),Tp=h(),so=n("p"),od=s("To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),zp=h(),he=n("ol"),Be=n("li"),cd=s("Initialize an "),oo=n("a"),ld=s("Accelerator"),nd=s(" object (that we will call "),gc=n("code"),pd=s("accelerator"),id=s(" throughout this page) as early as possible in your script."),dd=h(),dr=n("li"),md=s("Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),co=n("a"),hd=s("prepare()"),gd=s(" method."),fd=h(),pe=n("li"),ud=s("Remove all the "),fc=n("code"),_d=s(".cuda()"),$d=s(" or "),uc=n("code"),vd=s(".to(device)"),bd=s(" from your code and let the "),_c=n("code"),wd=s("accelerator"),jd=s(" handle the device placement for you."),Op=h(),v(bt.$$.fragment),Cp=h(),Je=n("ol"),wt=n("li"),yd=s("Replace "),$c=n("code"),kd=s("loss.backward()"),Ad=s(" in your code with "),vc=n("code"),Ed=s("accelerator.backward(loss)"),xd=h(),lo=n("li"),Pd=s("Gather your predictions and labels before storing them or using them for metric computation using "),no=n("a"),Dd=s("gather()"),qp=h(),v(jt.$$.fragment),Lp=h(),yt=n("p"),Td=s(`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),bc=n("code"),zd=s("accelerator"),Od=s(":"),Sp=h(),Ke=n("h2"),kt=n("a"),wc=n("span"),v(mr.$$.fragment),Cd=h(),jc=n("span"),qd=s("Advanced recommendations"),Ip=h(),Qe=n("h3"),At=n("a"),yc=n("span"),v(hr.$$.fragment),Ld=h(),kc=n("span"),Sd=s("Printing"),Np=h(),Xe=n("p"),Ac=n("code"),Id=s("print"),Nd=s(" statements should be replaced by "),po=n("a"),Md=s("print()"),Ud=s(" to be printed once per process"),Mp=h(),v(gr.$$.fragment),Up=h(),Ze=n("h3"),Et=n("a"),Ec=n("span"),v(fr.$$.fragment),Rd=h(),xc=n("span"),Gd=s("Executing processes"),Rp=h(),et=n("h4"),xt=n("a"),Pc=n("span"),v(ur.$$.fragment),Vd=h(),Dc=n("span"),Wd=s("Once on a single server"),Gp=h(),Pt=n("p"),Fd=s("For statements that should be executed once per server, use "),Tc=n("code"),Hd=s("is_local_main_process"),Yd=s(":"),Vp=h(),v(_r.$$.fragment),Wp=h(),Dt=n("p"),Bd=s("A function can be wrapped using the "),io=n("a"),Jd=s("on_local_main_process()"),Kd=s(` function to achieve the same
behavior on a function\u2019s execution:`),Fp=h(),v($r.$$.fragment),Hp=h(),tt=n("h4"),Tt=n("a"),zc=n("span"),v(vr.$$.fragment),Qd=h(),Oc=n("span"),Xd=s("Only ever once across all servers"),Yp=h(),zt=n("p"),Zd=s("For statements that should only ever be executed once, use "),Cc=n("code"),em=s("is_main_process"),tm=s(":"),Bp=h(),v(br.$$.fragment),Jp=h(),Ot=n("p"),am=s("A function can be wrapped using the "),mo=n("a"),rm=s("on_main_process()"),sm=s(` function to achieve the same
behavior on a function\u2019s execution:`),Kp=h(),v(wr.$$.fragment),Qp=h(),at=n("h4"),Ct=n("a"),qc=n("span"),v(jr.$$.fragment),om=h(),Lc=n("span"),cm=s("On specific processes"),Xp=h(),ho=n("p"),lm=s(`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),Zp=h(),v(yr.$$.fragment),ei=h(),v(kr.$$.fragment),ti=h(),rt=n("h3"),qt=n("a"),Sc=n("span"),v(Ar.$$.fragment),nm=h(),Ic=n("span"),pm=s("Synchronicity control"),ai=h(),Lt=n("p"),im=s("Use "),go=n("a"),dm=s("wait_for_everyone()"),mm=s(" to make sure all processes join that point before continuing. (Useful before a model save for instance)"),ri=h(),st=n("h3"),St=n("a"),Nc=n("span"),v(Er.$$.fragment),hm=h(),Mc=n("span"),gm=s("Saving and loading"),si=h(),It=n("p"),fm=s("Use "),fo=n("a"),um=s("unwrap_model()"),_m=s(" before saving to remove all special model wrappers added during the distributed process."),oi=h(),v(xr.$$.fragment),ci=h(),ge=n("p"),$m=s("Use "),uo=n("a"),vm=s("save()"),bm=s(" instead of "),Uc=n("code"),wm=s("torch.save"),jm=s(":"),li=h(),v(Pr.$$.fragment),ni=h(),ot=n("h3"),Nt=n("a"),Rc=n("span"),v(Dr.$$.fragment),ym=h(),Gc=n("span"),km=s("Operations"),pi=h(),Y=n("p"),Am=s("Use "),Mt=n("a"),Em=s("clip"),Vc=n("em"),xm=s("grad_norm"),Pm=s("()"),Dm=s(" instead of "),Wc=n("code"),Tm=s("torch.nn.utils.clip_grad_norm_"),zm=s(" and "),Ut=n("a"),Om=s("clip"),Fc=n("em"),Cm=s("grad_value"),qm=s("()"),Lm=s(" instead of "),Hc=n("code"),Sm=s("torch.nn.utils.clip_grad_value"),ii=h(),ct=n("h3"),Rt=n("a"),Yc=n("span"),v(Tr.$$.fragment),Im=h(),Bc=n("span"),Nm=s("Gradient Accumulation"),di=h(),Gt=n("p"),Mm=s("To perform gradient accumulation use "),_o=n("a"),Um=s("accumulate()"),Rm=s(` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),mi=h(),v(zr.$$.fragment),hi=h(),lt=n("h2"),Vt=n("a"),Jc=n("span"),v(Or.$$.fragment),Gm=h(),Kc=n("span"),Vm=s("Overall API documentation:"),gi=h(),x=n("div"),v(Cr.$$.fragment),Wm=h(),Qc=n("p"),Fm=s("Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Hm=h(),Xc=n("p"),Zc=n("strong"),Ym=s("Available attributes:"),Bm=h(),C=n("ul"),Wt=n("li"),el=n("strong"),Jm=s("device"),Km=s(" ("),tl=n("code"),Qm=s("torch.device"),Xm=s(") \u2014 The device to use."),Zm=h(),Ft=n("li"),al=n("strong"),eh=s("distributed_type"),th=s(" ("),$o=n("a"),ah=s("DistributedType"),rh=s(") \u2014 The distributed training configuration."),sh=h(),Ht=n("li"),rl=n("strong"),oh=s("local_process_index"),ch=s(" ("),sl=n("code"),lh=s("int"),nh=s(") \u2014 The process index on the current machine."),ph=h(),Yt=n("li"),ol=n("strong"),ih=s("mixed_precision"),dh=s(" ("),cl=n("code"),mh=s("str"),hh=s(") \u2014 The configured mixed precision mode."),gh=h(),Bt=n("li"),ll=n("strong"),fh=s("num_processes"),uh=s(" ("),nl=n("code"),_h=s("int"),$h=s(") \u2014 The total number of processes used for training."),vh=h(),Jt=n("li"),pl=n("strong"),bh=s("optimizer_step_was_skipped"),wh=s(" ("),il=n("code"),jh=s("bool"),yh=s(`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),kh=h(),Kt=n("li"),dl=n("strong"),Ah=s("process_index"),Eh=s(" ("),ml=n("code"),xh=s("int"),Ph=s(") \u2014 The overall index of the current process among all processes."),Dh=h(),Qt=n("li"),hl=n("strong"),Th=s("state"),zh=s(" ("),vo=n("a"),Oh=s("AcceleratorState"),Ch=s(") \u2014 The distributed setup state."),qh=h(),Xt=n("li"),gl=n("strong"),Lh=s("sync_gradients"),Sh=s(" ("),fl=n("code"),Ih=s("bool"),Nh=s(") \u2014 Whether the gradients are currently being synced across all processes."),Mh=h(),Zt=n("li"),ul=n("strong"),Uh=s("use_distributed"),Rh=s(" ("),_l=n("code"),Gh=s("bool"),Vh=s(") \u2014 Whether the current configuration is for distributed training."),Wh=h(),fe=n("div"),v(qr.$$.fragment),Fh=h(),$l=n("p"),Hh=s("A context manager that will lightly wrap around and perform gradient accumulation automatically"),Yh=h(),v(ea.$$.fragment),Bh=h(),ue=n("div"),v(Lr.$$.fragment),Jh=h(),vl=n("p"),Kh=s(`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),Qh=h(),v(ta.$$.fragment),Xh=h(),K=n("div"),v(Sr.$$.fragment),Zh=h(),nt=n("p"),eg=s("Scales the gradients in accordance to "),bl=n("code"),tg=s("Accelerator.gradient_accumulation_steps"),ag=s(` and calls the correct
`),wl=n("code"),rg=s("backward()"),sg=s(" based on the configuration."),og=h(),Ir=n("p"),cg=s("Should be used in lieu of "),jl=n("code"),lg=s("loss.backward()"),ng=s("."),pg=h(),v(aa.$$.fragment),ig=h(),_e=n("div"),v(Nr.$$.fragment),dg=h(),Mr=n("p"),mg=s("Alias for "),yl=n("code"),hg=s("Accelerate.free_memory"),gg=s(`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),fg=h(),v(ra.$$.fragment),ug=h(),$e=n("div"),v(Ur.$$.fragment),_g=h(),Rr=n("p"),$g=s("Should be used in place of "),kl=n("code"),vg=s("torch.nn.utils.clip_grad_norm_"),bg=s("."),wg=h(),v(sa.$$.fragment),jg=h(),ve=n("div"),v(Gr.$$.fragment),yg=h(),Vr=n("p"),kg=s("Should be used in place of "),Al=n("code"),Ag=s("torch.nn.utils.clip_grad_value_"),Eg=s("."),xg=h(),v(oa.$$.fragment),Pg=h(),be=n("div"),v(Wr.$$.fragment),Dg=h(),El=n("p"),Tg=s(`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),zg=h(),v(ca.$$.fragment),Og=h(),we=n("div"),v(Fr.$$.fragment),Cg=h(),xl=n("p"),qg=s(`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),Lg=h(),v(la.$$.fragment),Sg=h(),Q=n("div"),v(Hr.$$.fragment),Ig=h(),Yr=n("p"),Ng=s("Gather the values in "),Pl=n("em"),Mg=s("tensor"),Ug=s(` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),Rg=h(),Dl=n("p"),Gg=s(`Note:
This gather happens in all processes.`),Vg=h(),v(na.$$.fragment),Wg=h(),je=n("div"),v(Br.$$.fragment),Fg=h(),Jr=n("p"),Hg=s("Gathers "),Tl=n("code"),Yg=s("tensor"),Bg=s(` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),Jg=h(),v(pa.$$.fragment),Kg=h(),ye=n("div"),v(Kr.$$.fragment),Qg=h(),Qr=n("p"),Xg=s("Returns the state dictionary of a model sent through "),bo=n("a"),Zg=s("Accelerator.prepare()"),ef=s(` potentially without full
precision.`),tf=h(),v(ia.$$.fragment),af=h(),ke=n("div"),v(Xr.$$.fragment),rf=h(),ie=n("p"),sf=s("Returns a "),zl=n("code"),of=s("tracker"),cf=s(" from "),Ol=n("code"),lf=s("self.trackers"),nf=s(" based on "),Cl=n("code"),pf=s("name"),df=s(" on the main process only."),mf=h(),v(da.$$.fragment),hf=h(),Ae=n("div"),v(Zr.$$.fragment),gf=h(),es=n("p"),ff=s("Initializes a run for all trackers stored in "),ql=n("code"),uf=s("self.log_with"),_f=s(", potentially with starting configurations"),$f=h(),v(ma.$$.fragment),vf=h(),W=n("div"),v(ts.$$.fragment),bf=h(),as=n("p"),wf=s(`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),Ll=n("code"),jf=s("torch.distributed.algorithms.join"),yf=s(`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),kf=h(),v(ha.$$.fragment),Af=h(),v(ga.$$.fragment),Ef=h(),v(fa.$$.fragment),xf=h(),X=n("div"),v(rs.$$.fragment),Pf=h(),Sl=n("p"),Df=s("Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),Tf=h(),v(ua.$$.fragment),zf=h(),v(_a.$$.fragment),Of=h(),Z=n("div"),v(ss.$$.fragment),Cf=h(),Il=n("p"),qf=s("Lets the local main process go inside a with block."),Lf=h(),Nl=n("p"),Sf=s("The other processes will enter the with block after the main process exits."),If=h(),v($a.$$.fragment),Nf=h(),Ee=n("div"),v(os.$$.fragment),Mf=h(),pt=n("p"),Uf=s("Logs "),Ml=n("code"),Rf=s("values"),Gf=s(" to all stored trackers in "),Ul=n("code"),Vf=s("self.trackers"),Wf=s(" on the main process only."),Ff=h(),v(va.$$.fragment),Hf=h(),ee=n("div"),v(cs.$$.fragment),Yf=h(),Rl=n("p"),Bf=s("Lets the main process go first inside a with block."),Jf=h(),Gl=n("p"),Kf=s("The other processes will enter the with block after the main process exits."),Qf=h(),v(ba.$$.fragment),Xf=h(),te=n("div"),v(ls.$$.fragment),Zf=h(),ns=n("p"),eu=s(`A context manager to disable gradient synchronizations across DDP processes by calling
`),Vl=n("code"),tu=s("torch.nn.parallel.DistributedDataParallel.no_sync"),au=s("."),ru=h(),ps=n("p"),su=s("If "),Wl=n("code"),ou=s("model"),cu=s(" is not in DDP, this context manager does nothing"),lu=h(),v(wa.$$.fragment),nu=h(),xe=n("div"),v(is.$$.fragment),pu=h(),ds=n("p"),iu=s(`A decorator that will run the decorated function on the last process only. Can also be called using the
`),Fl=n("code"),du=s("PartialState"),mu=s(" class."),hu=h(),v(ja.$$.fragment),gu=h(),Pe=n("div"),v(ms.$$.fragment),fu=h(),hs=n("p"),uu=s(`A decorator that will run the decorated function on the local main process only. Can also be called using the
`),Hl=n("code"),_u=s("PartialState"),$u=s(" class."),vu=h(),v(ya.$$.fragment),bu=h(),De=n("div"),v(gs.$$.fragment),wu=h(),fs=n("p"),ju=s(`A decorator that will run the decorated function on a given local process index only. Can also be called using
the `),Yl=n("code"),yu=s("PartialState"),ku=s(" class."),Au=h(),v(ka.$$.fragment),Eu=h(),Te=n("div"),v(us.$$.fragment),xu=h(),_s=n("p"),Pu=s(`A decorator that will run the decorated function on the main process only. Can also be called using the
`),Bl=n("code"),Du=s("PartialState"),Tu=s(" class."),zu=h(),v(Aa.$$.fragment),Ou=h(),ze=n("div"),v($s.$$.fragment),Cu=h(),vs=n("p"),qu=s(`A decorator that will run the decorated function on a given process index only. Can also be called using the
`),Jl=n("code"),Lu=s("PartialState"),Su=s(" class."),Iu=h(),v(Ea.$$.fragment),Nu=h(),Oe=n("div"),v(bs.$$.fragment),Mu=h(),Kl=n("p"),Uu=s(`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),Ru=h(),v(xa.$$.fragment),Gu=h(),ae=n("div"),v(ws.$$.fragment),Vu=h(),js=n("p"),Wu=s("Prepare all objects passed in "),Ql=n("code"),Fu=s("args"),Hu=s(` for distributed training and mixed precision, then return them in the same
order.`),Yu=h(),v(Pa.$$.fragment),Bu=h(),v(Da.$$.fragment),Ju=h(),Ce=n("div"),v(ys.$$.fragment),Ku=h(),ks=n("p"),Qu=s(`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),wo=n("a"),Xu=s("Accelerator.prepare()"),Zu=s(" instead."),e_=h(),v(Ta.$$.fragment),t_=h(),qe=n("div"),v(As.$$.fragment),a_=h(),Es=n("p"),r_=s(`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),jo=n("a"),s_=s("Accelerator.prepare()"),o_=s(" instead."),c_=h(),v(za.$$.fragment),l_=h(),Le=n("div"),v(xs.$$.fragment),n_=h(),Ps=n("p"),p_=s(`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),yo=n("a"),i_=s("Accelerator.prepare()"),d_=s(" instead."),m_=h(),v(Oa.$$.fragment),h_=h(),Se=n("div"),v(Ds.$$.fragment),g_=h(),Ts=n("p"),f_=s(`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),ko=n("a"),u_=s("Accelerator.prepare()"),__=s(" instead."),$_=h(),v(Ca.$$.fragment),v_=h(),Ie=n("div"),v(zs.$$.fragment),b_=h(),Os=n("p"),w_=s("Drop in replacement of "),Xl=n("code"),j_=s("print()"),y_=s(" to only print once per server."),k_=h(),v(qa.$$.fragment),A_=h(),re=n("div"),v(Cs.$$.fragment),E_=h(),it=n("p"),x_=s("Reduce the values in "),Zl=n("em"),P_=s("tensor"),D_=s(" across all processes based on "),en=n("em"),T_=s("reduction"),z_=s("."),O_=h(),tn=n("p"),C_=s(`Note:
All processes get the reduced value.`),q_=h(),v(La.$$.fragment),L_=h(),F=n("div"),v(qs.$$.fragment),S_=h(),de=n("p"),I_=s("Makes note of "),an=n("code"),N_=s("objects"),M_=s(" and will save or load them in during "),rn=n("code"),U_=s("save_state"),R_=s(" or "),sn=n("code"),G_=s("load_state"),V_=s("."),W_=h(),on=n("p"),F_=s(`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts.`),H_=h(),v(Sa.$$.fragment),Y_=h(),v(Ia.$$.fragment),B_=h(),M=n("div"),v(Ls.$$.fragment),J_=h(),dt=n("p"),K_=s("Registers a pre hook to be run before "),cn=n("code"),Q_=s("load_checkpoint"),X_=s(" is called in "),Ao=n("a"),Z_=s("Accelerator.load_state()"),e$=s("."),t$=h(),ln=n("p"),a$=s("The hook should have the following signature:"),r$=h(),nn=n("p"),pn=n("code"),s$=s("hook(models: List[torch.nn.Module], input_dir: str) -> None"),o$=h(),V=n("p"),c$=s("The "),dn=n("code"),l$=s("models"),n$=s(" argument are the models as saved in the accelerator state under "),mn=n("code"),p$=s("accelerator._models"),i$=s(`, and the
`),hn=n("code"),d$=s("input_dir"),m$=s(" argument is the "),gn=n("code"),h$=s("input_dir"),g$=s(" argument passed to "),Eo=n("a"),f$=s("Accelerator.load_state()"),u$=s("."),_$=h(),v(Na.$$.fragment),$$=h(),U=n("div"),v(Ss.$$.fragment),v$=h(),mt=n("p"),b$=s("Registers a pre hook to be run before "),fn=n("code"),w$=s("save_checkpoint"),j$=s(" is called in "),xo=n("a"),y$=s("Accelerator.save_state()"),k$=s("."),A$=h(),un=n("p"),E$=s("The hook should have the following signature:"),x$=h(),_n=n("p"),$n=n("code"),P$=s("hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),D$=h(),S=n("p"),T$=s("The "),vn=n("code"),z$=s("models"),O$=s(" argument are the models as saved in the accelerator state under "),bn=n("code"),C$=s("accelerator._models"),q$=s(", "),wn=n("code"),L$=s("weigths"),S$=s(`
argument are the state dicts of the `),jn=n("code"),I$=s("models"),N$=s(", and the "),yn=n("code"),M$=s("input_dir"),U$=s(" argument is the "),kn=n("code"),R$=s("input_dir"),G$=s(` argument passed
to `),Po=n("a"),V$=s("Accelerator.load_state()"),W$=s("."),F$=h(),v(Ma.$$.fragment),H$=h(),Ne=n("div"),v(Is.$$.fragment),Y$=h(),Ns=n("p"),B$=s("Save the object passed to disk once per machine. Use in place of "),An=n("code"),J$=s("torch.save"),K$=s("."),Q$=h(),v(Ua.$$.fragment),X$=h(),R=n("div"),v(Ms.$$.fragment),Z$=h(),En=n("p"),ev=s("Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),tv=h(),N=n("p"),av=s("If a "),xn=n("code"),rv=s("ProjectConfiguration"),sv=s(" was passed to the "),Pn=n("code"),ov=s("Accelerator"),cv=s(" object with "),Dn=n("code"),lv=s("automatic_checkpoint_naming"),nv=s(` enabled
then checkpoints will be saved to `),Tn=n("code"),pv=s("self.project_dir/checkpoints"),iv=s(`. If the number of current saves is greater
than `),zn=n("code"),dv=s("total_limit"),mv=s(` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),On=n("code"),hv=s("checkpoint_<iteration>"),gv=s("."),fv=h(),Us=n("p"),uv=s("Otherwise they are just saved to "),Cn=n("code"),_v=s("output_dir"),$v=s("."),vv=h(),v(Ra.$$.fragment),bv=h(),v(Ga.$$.fragment),wv=h(),Me=n("div"),v(Rs.$$.fragment),jv=h(),ht=n("p"),yv=s("Creates a new "),qn=n("code"),kv=s("torch.utils.data.DataLoader"),Av=s(" that will efficiently skip the first "),Ln=n("code"),Ev=s("num_batches"),xv=s("."),Pv=h(),v(Va.$$.fragment),Dv=h(),se=n("div"),v(Gs.$$.fragment),Tv=h(),Sn=n("p"),zv=s("Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),Ov=h(),Wa=n("p"),Cv=s("Likely should be called through "),Fa=n("a"),qv=s("Accelerator.clip"),In=n("em"),Lv=s("grad_norm"),Sv=s("()"),Iv=s(" or "),Ha=n("a"),Nv=s("Accelerator.clip"),Nn=n("em"),Mv=s("grad_value"),Uv=s("()"),Rv=h(),v(Ya.$$.fragment),Gv=h(),Ue=n("div"),v(Vs.$$.fragment),Vv=h(),gt=n("p"),Wv=s("Unwraps the "),Mn=n("code"),Fv=s("model"),Hv=s(" from the additional layer possible added by "),Do=n("a"),Yv=s("prepare()"),Bv=s(`. Useful before saving
the model.`),Jv=h(),v(Ba.$$.fragment),Kv=h(),Re=n("div"),v(Ws.$$.fragment),Qv=h(),Un=n("p"),Xv=s(`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),Zv=h(),v(Ja.$$.fragment),this.h()},l(a){const _=M2('[data-svelte="svelte-1phssyn"]',document.head);c=p(_,"META",{name:!0,content:!0}),_.forEach(r),u=g(a),m=p(a,"H1",{class:!0});var Fs=i(m);l=p(Fs,"A",{id:!0,class:!0,href:!0});var Rn=i(l);f=p(Rn,"SPAN",{});var Gn=i(f);b(t.$$.fragment,Gn),Gn.forEach(r),Rn.forEach(r),d=g(Fs),q=p(Fs,"SPAN",{});var Vn=i(q);Fe=o(Vn,"Accelerator"),Vn.forEach(r),Fs.forEach(r),$t=g(a),J=p(a,"P",{});var Hs=i(J);He=o(Hs,"The "),I=p(Hs,"A",{href:!0});var Wn=i(I);ao=o(Wn,"Accelerator"),Wn.forEach(r),ro=o(Hs,` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),Hs.forEach(r),pr=g(a),Ye=p(a,"H2",{class:!0});var Ys=i(Ye);vt=p(Ys,"A",{id:!0,class:!0,href:!0});var Fn=i(vt);mc=p(Fn,"SPAN",{});var Hn=i(mc);b(ir.$$.fragment,Hn),Hn.forEach(r),Fn.forEach(r),rd=g(Ys),hc=p(Ys,"SPAN",{});var Yn=i(hc);sd=o(Yn,"Quick adaptation of your code"),Yn.forEach(r),Ys.forEach(r),Tp=g(a),so=p(a,"P",{});var Bn=i(so);od=o(Bn,"To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),Bn.forEach(r),zp=g(a),he=p(a,"OL",{});var ft=i(he);Be=p(ft,"LI",{});var ut=i(Be);cd=o(ut,"Initialize an "),oo=p(ut,"A",{href:!0});var Jn=i(oo);ld=o(Jn,"Accelerator"),Jn.forEach(r),nd=o(ut," object (that we will call "),gc=p(ut,"CODE",{});var Kn=i(gc);pd=o(Kn,"accelerator"),Kn.forEach(r),id=o(ut," throughout this page) as early as possible in your script."),ut.forEach(r),dd=g(ft),dr=p(ft,"LI",{});var Bs=i(dr);md=o(Bs,"Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),co=p(Bs,"A",{href:!0});var Qn=i(co);hd=o(Qn,"prepare()"),Qn.forEach(r),gd=o(Bs," method."),Bs.forEach(r),fd=g(ft),pe=p(ft,"LI",{});var me=i(pe);ud=o(me,"Remove all the "),fc=p(me,"CODE",{});var Xn=i(fc);_d=o(Xn,".cuda()"),Xn.forEach(r),$d=o(me," or "),uc=p(me,"CODE",{});var Zn=i(uc);vd=o(Zn,".to(device)"),Zn.forEach(r),bd=o(me," from your code and let the "),_c=p(me,"CODE",{});var ep=i(_c);wd=o(ep,"accelerator"),ep.forEach(r),jd=o(me," handle the device placement for you."),me.forEach(r),ft.forEach(r),Op=g(a),b(bt.$$.fragment,a),Cp=g(a),Je=p(a,"OL",{start:!0});var Js=i(Je);wt=p(Js,"LI",{});var Ka=i(wt);yd=o(Ka,"Replace "),$c=p(Ka,"CODE",{});var tp=i($c);kd=o(tp,"loss.backward()"),tp.forEach(r),Ad=o(Ka," in your code with "),vc=p(Ka,"CODE",{});var ap=i(vc);Ed=o(ap,"accelerator.backward(loss)"),ap.forEach(r),Ka.forEach(r),xd=g(Js),lo=p(Js,"LI",{});var To=i(lo);Pd=o(To,"Gather your predictions and labels before storing them or using them for metric computation using "),no=p(To,"A",{href:!0});var rp=i(no);Dd=o(rp,"gather()"),rp.forEach(r),To.forEach(r),Js.forEach(r),qp=g(a),b(jt.$$.fragment,a),Lp=g(a),yt=p(a,"P",{});var Ks=i(yt);Td=o(Ks,`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),bc=p(Ks,"CODE",{});var sp=i(bc);zd=o(sp,"accelerator"),sp.forEach(r),Od=o(Ks,":"),Ks.forEach(r),Sp=g(a),Ke=p(a,"H2",{class:!0});var Qs=i(Ke);kt=p(Qs,"A",{id:!0,class:!0,href:!0});var op=i(kt);wc=p(op,"SPAN",{});var cp=i(wc);b(mr.$$.fragment,cp),cp.forEach(r),op.forEach(r),Cd=g(Qs),jc=p(Qs,"SPAN",{});var lp=i(jc);qd=o(lp,"Advanced recommendations"),lp.forEach(r),Qs.forEach(r),Ip=g(a),Qe=p(a,"H3",{class:!0});var Xs=i(Qe);At=p(Xs,"A",{id:!0,class:!0,href:!0});var np=i(At);yc=p(np,"SPAN",{});var pp=i(yc);b(hr.$$.fragment,pp),pp.forEach(r),np.forEach(r),Ld=g(Xs),kc=p(Xs,"SPAN",{});var ip=i(kc);Sd=o(ip,"Printing"),ip.forEach(r),Xs.forEach(r),Np=g(a),Xe=p(a,"P",{});var Qa=i(Xe);Ac=p(Qa,"CODE",{});var dp=i(Ac);Id=o(dp,"print"),dp.forEach(r),Nd=o(Qa," statements should be replaced by "),po=p(Qa,"A",{href:!0});var mp=i(po);Md=o(mp,"print()"),mp.forEach(r),Ud=o(Qa," to be printed once per process"),Qa.forEach(r),Mp=g(a),b(gr.$$.fragment,a),Up=g(a),Ze=p(a,"H3",{class:!0});var Zs=i(Ze);Et=p(Zs,"A",{id:!0,class:!0,href:!0});var hp=i(Et);Ec=p(hp,"SPAN",{});var gp=i(Ec);b(fr.$$.fragment,gp),gp.forEach(r),hp.forEach(r),Rd=g(Zs),xc=p(Zs,"SPAN",{});var fp=i(xc);Gd=o(fp,"Executing processes"),fp.forEach(r),Zs.forEach(r),Rp=g(a),et=p(a,"H4",{class:!0});var eo=i(et);xt=p(eo,"A",{id:!0,class:!0,href:!0});var up=i(xt);Pc=p(up,"SPAN",{});var _p=i(Pc);b(ur.$$.fragment,_p),_p.forEach(r),up.forEach(r),Vd=g(eo),Dc=p(eo,"SPAN",{});var $p=i(Dc);Wd=o($p,"Once on a single server"),$p.forEach(r),eo.forEach(r),Gp=g(a),Pt=p(a,"P",{});var to=i(Pt);Fd=o(to,"For statements that should be executed once per server, use "),Tc=p(to,"CODE",{});var eb=i(Tc);Hd=o(eb,"is_local_main_process"),eb.forEach(r),Yd=o(to,":"),to.forEach(r),Vp=g(a),b(_r.$$.fragment,a),Wp=g(a),Dt=p(a,"P",{});var ui=i(Dt);Bd=o(ui,"A function can be wrapped using the "),io=p(ui,"A",{href:!0});var tb=i(io);Jd=o(tb,"on_local_main_process()"),tb.forEach(r),Kd=o(ui,` function to achieve the same
behavior on a function\u2019s execution:`),ui.forEach(r),Fp=g(a),b($r.$$.fragment,a),Hp=g(a),tt=p(a,"H4",{class:!0});var _i=i(tt);Tt=p(_i,"A",{id:!0,class:!0,href:!0});var ab=i(Tt);zc=p(ab,"SPAN",{});var rb=i(zc);b(vr.$$.fragment,rb),rb.forEach(r),ab.forEach(r),Qd=g(_i),Oc=p(_i,"SPAN",{});var sb=i(Oc);Xd=o(sb,"Only ever once across all servers"),sb.forEach(r),_i.forEach(r),Yp=g(a),zt=p(a,"P",{});var $i=i(zt);Zd=o($i,"For statements that should only ever be executed once, use "),Cc=p($i,"CODE",{});var ob=i(Cc);em=o(ob,"is_main_process"),ob.forEach(r),tm=o($i,":"),$i.forEach(r),Bp=g(a),b(br.$$.fragment,a),Jp=g(a),Ot=p(a,"P",{});var vi=i(Ot);am=o(vi,"A function can be wrapped using the "),mo=p(vi,"A",{href:!0});var cb=i(mo);rm=o(cb,"on_main_process()"),cb.forEach(r),sm=o(vi,` function to achieve the same
behavior on a function\u2019s execution:`),vi.forEach(r),Kp=g(a),b(wr.$$.fragment,a),Qp=g(a),at=p(a,"H4",{class:!0});var bi=i(at);Ct=p(bi,"A",{id:!0,class:!0,href:!0});var lb=i(Ct);qc=p(lb,"SPAN",{});var nb=i(qc);b(jr.$$.fragment,nb),nb.forEach(r),lb.forEach(r),om=g(bi),Lc=p(bi,"SPAN",{});var pb=i(Lc);cm=o(pb,"On specific processes"),pb.forEach(r),bi.forEach(r),Xp=g(a),ho=p(a,"P",{});var ib=i(ho);lm=o(ib,`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),ib.forEach(r),Zp=g(a),b(yr.$$.fragment,a),ei=g(a),b(kr.$$.fragment,a),ti=g(a),rt=p(a,"H3",{class:!0});var wi=i(rt);qt=p(wi,"A",{id:!0,class:!0,href:!0});var db=i(qt);Sc=p(db,"SPAN",{});var mb=i(Sc);b(Ar.$$.fragment,mb),mb.forEach(r),db.forEach(r),nm=g(wi),Ic=p(wi,"SPAN",{});var hb=i(Ic);pm=o(hb,"Synchronicity control"),hb.forEach(r),wi.forEach(r),ai=g(a),Lt=p(a,"P",{});var ji=i(Lt);im=o(ji,"Use "),go=p(ji,"A",{href:!0});var gb=i(go);dm=o(gb,"wait_for_everyone()"),gb.forEach(r),mm=o(ji," to make sure all processes join that point before continuing. (Useful before a model save for instance)"),ji.forEach(r),ri=g(a),st=p(a,"H3",{class:!0});var yi=i(st);St=p(yi,"A",{id:!0,class:!0,href:!0});var fb=i(St);Nc=p(fb,"SPAN",{});var ub=i(Nc);b(Er.$$.fragment,ub),ub.forEach(r),fb.forEach(r),hm=g(yi),Mc=p(yi,"SPAN",{});var _b=i(Mc);gm=o(_b,"Saving and loading"),_b.forEach(r),yi.forEach(r),si=g(a),It=p(a,"P",{});var ki=i(It);fm=o(ki,"Use "),fo=p(ki,"A",{href:!0});var $b=i(fo);um=o($b,"unwrap_model()"),$b.forEach(r),_m=o(ki," before saving to remove all special model wrappers added during the distributed process."),ki.forEach(r),oi=g(a),b(xr.$$.fragment,a),ci=g(a),ge=p(a,"P",{});var zo=i(ge);$m=o(zo,"Use "),uo=p(zo,"A",{href:!0});var vb=i(uo);vm=o(vb,"save()"),vb.forEach(r),bm=o(zo," instead of "),Uc=p(zo,"CODE",{});var bb=i(Uc);wm=o(bb,"torch.save"),bb.forEach(r),jm=o(zo,":"),zo.forEach(r),li=g(a),b(Pr.$$.fragment,a),ni=g(a),ot=p(a,"H3",{class:!0});var Ai=i(ot);Nt=p(Ai,"A",{id:!0,class:!0,href:!0});var wb=i(Nt);Rc=p(wb,"SPAN",{});var jb=i(Rc);b(Dr.$$.fragment,jb),jb.forEach(r),wb.forEach(r),ym=g(Ai),Gc=p(Ai,"SPAN",{});var yb=i(Gc);km=o(yb,"Operations"),yb.forEach(r),Ai.forEach(r),pi=g(a),Y=p(a,"P",{});var _t=i(Y);Am=o(_t,"Use "),Mt=p(_t,"A",{href:!0});var Ei=i(Mt);Em=o(Ei,"clip"),Vc=p(Ei,"EM",{});var kb=i(Vc);xm=o(kb,"grad_norm"),kb.forEach(r),Pm=o(Ei,"()"),Ei.forEach(r),Dm=o(_t," instead of "),Wc=p(_t,"CODE",{});var Ab=i(Wc);Tm=o(Ab,"torch.nn.utils.clip_grad_norm_"),Ab.forEach(r),zm=o(_t," and "),Ut=p(_t,"A",{href:!0});var xi=i(Ut);Om=o(xi,"clip"),Fc=p(xi,"EM",{});var Eb=i(Fc);Cm=o(Eb,"grad_value"),Eb.forEach(r),qm=o(xi,"()"),xi.forEach(r),Lm=o(_t," instead of "),Hc=p(_t,"CODE",{});var xb=i(Hc);Sm=o(xb,"torch.nn.utils.clip_grad_value"),xb.forEach(r),_t.forEach(r),ii=g(a),ct=p(a,"H3",{class:!0});var Pi=i(ct);Rt=p(Pi,"A",{id:!0,class:!0,href:!0});var Pb=i(Rt);Yc=p(Pb,"SPAN",{});var Db=i(Yc);b(Tr.$$.fragment,Db),Db.forEach(r),Pb.forEach(r),Im=g(Pi),Bc=p(Pi,"SPAN",{});var Tb=i(Bc);Nm=o(Tb,"Gradient Accumulation"),Tb.forEach(r),Pi.forEach(r),di=g(a),Gt=p(a,"P",{});var Di=i(Gt);Mm=o(Di,"To perform gradient accumulation use "),_o=p(Di,"A",{href:!0});var zb=i(_o);Um=o(zb,"accumulate()"),zb.forEach(r),Rm=o(Di,` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),Di.forEach(r),mi=g(a),b(zr.$$.fragment,a),hi=g(a),lt=p(a,"H2",{class:!0});var Ti=i(lt);Vt=p(Ti,"A",{id:!0,class:!0,href:!0});var Ob=i(Vt);Jc=p(Ob,"SPAN",{});var Cb=i(Jc);b(Or.$$.fragment,Cb),Cb.forEach(r),Ob.forEach(r),Gm=g(Ti),Kc=p(Ti,"SPAN",{});var qb=i(Kc);Vm=o(qb,"Overall API documentation:"),qb.forEach(r),Ti.forEach(r),gi=g(a),x=p(a,"DIV",{class:!0});var P=i(x);b(Cr.$$.fragment,P),Wm=g(P),Qc=p(P,"P",{});var Lb=i(Qc);Fm=o(Lb,"Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Lb.forEach(r),Hm=g(P),Xc=p(P,"P",{});var Sb=i(Xc);Zc=p(Sb,"STRONG",{});var Ib=i(Zc);Ym=o(Ib,"Available attributes:"),Ib.forEach(r),Sb.forEach(r),Bm=g(P),C=p(P,"UL",{});var L=i(C);Wt=p(L,"LI",{});var vp=i(Wt);el=p(vp,"STRONG",{});var Nb=i(el);Jm=o(Nb,"device"),Nb.forEach(r),Km=o(vp," ("),tl=p(vp,"CODE",{});var Mb=i(tl);Qm=o(Mb,"torch.device"),Mb.forEach(r),Xm=o(vp,") \u2014 The device to use."),vp.forEach(r),Zm=g(L),Ft=p(L,"LI",{});var bp=i(Ft);al=p(bp,"STRONG",{});var Ub=i(al);eh=o(Ub,"distributed_type"),Ub.forEach(r),th=o(bp," ("),$o=p(bp,"A",{href:!0});var Rb=i($o);ah=o(Rb,"DistributedType"),Rb.forEach(r),rh=o(bp,") \u2014 The distributed training configuration."),bp.forEach(r),sh=g(L),Ht=p(L,"LI",{});var wp=i(Ht);rl=p(wp,"STRONG",{});var Gb=i(rl);oh=o(Gb,"local_process_index"),Gb.forEach(r),ch=o(wp," ("),sl=p(wp,"CODE",{});var Vb=i(sl);lh=o(Vb,"int"),Vb.forEach(r),nh=o(wp,") \u2014 The process index on the current machine."),wp.forEach(r),ph=g(L),Yt=p(L,"LI",{});var jp=i(Yt);ol=p(jp,"STRONG",{});var Wb=i(ol);ih=o(Wb,"mixed_precision"),Wb.forEach(r),dh=o(jp," ("),cl=p(jp,"CODE",{});var Fb=i(cl);mh=o(Fb,"str"),Fb.forEach(r),hh=o(jp,") \u2014 The configured mixed precision mode."),jp.forEach(r),gh=g(L),Bt=p(L,"LI",{});var yp=i(Bt);ll=p(yp,"STRONG",{});var Hb=i(ll);fh=o(Hb,"num_processes"),Hb.forEach(r),uh=o(yp," ("),nl=p(yp,"CODE",{});var Yb=i(nl);_h=o(Yb,"int"),Yb.forEach(r),$h=o(yp,") \u2014 The total number of processes used for training."),yp.forEach(r),vh=g(L),Jt=p(L,"LI",{});var kp=i(Jt);pl=p(kp,"STRONG",{});var Bb=i(pl);bh=o(Bb,"optimizer_step_was_skipped"),Bb.forEach(r),wh=o(kp," ("),il=p(kp,"CODE",{});var Jb=i(il);jh=o(Jb,"bool"),Jb.forEach(r),yh=o(kp,`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),kp.forEach(r),kh=g(L),Kt=p(L,"LI",{});var Ap=i(Kt);dl=p(Ap,"STRONG",{});var Kb=i(dl);Ah=o(Kb,"process_index"),Kb.forEach(r),Eh=o(Ap," ("),ml=p(Ap,"CODE",{});var Qb=i(ml);xh=o(Qb,"int"),Qb.forEach(r),Ph=o(Ap,") \u2014 The overall index of the current process among all processes."),Ap.forEach(r),Dh=g(L),Qt=p(L,"LI",{});var Ep=i(Qt);hl=p(Ep,"STRONG",{});var Xb=i(hl);Th=o(Xb,"state"),Xb.forEach(r),zh=o(Ep," ("),vo=p(Ep,"A",{href:!0});var Zb=i(vo);Oh=o(Zb,"AcceleratorState"),Zb.forEach(r),Ch=o(Ep,") \u2014 The distributed setup state."),Ep.forEach(r),qh=g(L),Xt=p(L,"LI",{});var xp=i(Xt);gl=p(xp,"STRONG",{});var e1=i(gl);Lh=o(e1,"sync_gradients"),e1.forEach(r),Sh=o(xp," ("),fl=p(xp,"CODE",{});var t1=i(fl);Ih=o(t1,"bool"),t1.forEach(r),Nh=o(xp,") \u2014 Whether the gradients are currently being synced across all processes."),xp.forEach(r),Mh=g(L),Zt=p(L,"LI",{});var Pp=i(Zt);ul=p(Pp,"STRONG",{});var a1=i(ul);Uh=o(a1,"use_distributed"),a1.forEach(r),Rh=o(Pp," ("),_l=p(Pp,"CODE",{});var r1=i(_l);Gh=o(r1,"bool"),r1.forEach(r),Vh=o(Pp,") \u2014 Whether the current configuration is for distributed training."),Pp.forEach(r),L.forEach(r),Wh=g(P),fe=p(P,"DIV",{class:!0});var Oo=i(fe);b(qr.$$.fragment,Oo),Fh=g(Oo),$l=p(Oo,"P",{});var s1=i($l);Hh=o(s1,"A context manager that will lightly wrap around and perform gradient accumulation automatically"),s1.forEach(r),Yh=g(Oo),b(ea.$$.fragment,Oo),Oo.forEach(r),Bh=g(P),ue=p(P,"DIV",{class:!0});var Co=i(ue);b(Lr.$$.fragment,Co),Jh=g(Co),vl=p(Co,"P",{});var o1=i(vl);Kh=o(o1,`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),o1.forEach(r),Qh=g(Co),b(ta.$$.fragment,Co),Co.forEach(r),Xh=g(P),K=p(P,"DIV",{class:!0});var Xa=i(K);b(Sr.$$.fragment,Xa),Zh=g(Xa),nt=p(Xa,"P",{});var qo=i(nt);eg=o(qo,"Scales the gradients in accordance to "),bl=p(qo,"CODE",{});var c1=i(bl);tg=o(c1,"Accelerator.gradient_accumulation_steps"),c1.forEach(r),ag=o(qo,` and calls the correct
`),wl=p(qo,"CODE",{});var l1=i(wl);rg=o(l1,"backward()"),l1.forEach(r),sg=o(qo," based on the configuration."),qo.forEach(r),og=g(Xa),Ir=p(Xa,"P",{});var zi=i(Ir);cg=o(zi,"Should be used in lieu of "),jl=p(zi,"CODE",{});var n1=i(jl);lg=o(n1,"loss.backward()"),n1.forEach(r),ng=o(zi,"."),zi.forEach(r),pg=g(Xa),b(aa.$$.fragment,Xa),Xa.forEach(r),ig=g(P),_e=p(P,"DIV",{class:!0});var Lo=i(_e);b(Nr.$$.fragment,Lo),dg=g(Lo),Mr=p(Lo,"P",{});var Oi=i(Mr);mg=o(Oi,"Alias for "),yl=p(Oi,"CODE",{});var p1=i(yl);hg=o(p1,"Accelerate.free_memory"),p1.forEach(r),gg=o(Oi,`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),Oi.forEach(r),fg=g(Lo),b(ra.$$.fragment,Lo),Lo.forEach(r),ug=g(P),$e=p(P,"DIV",{class:!0});var So=i($e);b(Ur.$$.fragment,So),_g=g(So),Rr=p(So,"P",{});var Ci=i(Rr);$g=o(Ci,"Should be used in place of "),kl=p(Ci,"CODE",{});var i1=i(kl);vg=o(i1,"torch.nn.utils.clip_grad_norm_"),i1.forEach(r),bg=o(Ci,"."),Ci.forEach(r),wg=g(So),b(sa.$$.fragment,So),So.forEach(r),jg=g(P),ve=p(P,"DIV",{class:!0});var Io=i(ve);b(Gr.$$.fragment,Io),yg=g(Io),Vr=p(Io,"P",{});var qi=i(Vr);kg=o(qi,"Should be used in place of "),Al=p(qi,"CODE",{});var d1=i(Al);Ag=o(d1,"torch.nn.utils.clip_grad_value_"),d1.forEach(r),Eg=o(qi,"."),qi.forEach(r),xg=g(Io),b(oa.$$.fragment,Io),Io.forEach(r),Pg=g(P),be=p(P,"DIV",{class:!0});var No=i(be);b(Wr.$$.fragment,No),Dg=g(No),El=p(No,"P",{});var m1=i(El);Tg=o(m1,`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),m1.forEach(r),zg=g(No),b(ca.$$.fragment,No),No.forEach(r),Og=g(P),we=p(P,"DIV",{class:!0});var Mo=i(we);b(Fr.$$.fragment,Mo),Cg=g(Mo),xl=p(Mo,"P",{});var h1=i(xl);qg=o(h1,`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),h1.forEach(r),Lg=g(Mo),b(la.$$.fragment,Mo),Mo.forEach(r),Sg=g(P),Q=p(P,"DIV",{class:!0});var Za=i(Q);b(Hr.$$.fragment,Za),Ig=g(Za),Yr=p(Za,"P",{});var Li=i(Yr);Ng=o(Li,"Gather the values in "),Pl=p(Li,"EM",{});var g1=i(Pl);Mg=o(g1,"tensor"),g1.forEach(r),Ug=o(Li,` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),Li.forEach(r),Rg=g(Za),Dl=p(Za,"P",{});var f1=i(Dl);Gg=o(f1,`Note:
This gather happens in all processes.`),f1.forEach(r),Vg=g(Za),b(na.$$.fragment,Za),Za.forEach(r),Wg=g(P),je=p(P,"DIV",{class:!0});var Uo=i(je);b(Br.$$.fragment,Uo),Fg=g(Uo),Jr=p(Uo,"P",{});var Si=i(Jr);Hg=o(Si,"Gathers "),Tl=p(Si,"CODE",{});var u1=i(Tl);Yg=o(u1,"tensor"),u1.forEach(r),Bg=o(Si,` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),Si.forEach(r),Jg=g(Uo),b(pa.$$.fragment,Uo),Uo.forEach(r),Kg=g(P),ye=p(P,"DIV",{class:!0});var Ro=i(ye);b(Kr.$$.fragment,Ro),Qg=g(Ro),Qr=p(Ro,"P",{});var Ii=i(Qr);Xg=o(Ii,"Returns the state dictionary of a model sent through "),bo=p(Ii,"A",{href:!0});var _1=i(bo);Zg=o(_1,"Accelerator.prepare()"),_1.forEach(r),ef=o(Ii,` potentially without full
precision.`),Ii.forEach(r),tf=g(Ro),b(ia.$$.fragment,Ro),Ro.forEach(r),af=g(P),ke=p(P,"DIV",{class:!0});var Go=i(ke);b(Xr.$$.fragment,Go),rf=g(Go),ie=p(Go,"P",{});var er=i(ie);sf=o(er,"Returns a "),zl=p(er,"CODE",{});var $1=i(zl);of=o($1,"tracker"),$1.forEach(r),cf=o(er," from "),Ol=p(er,"CODE",{});var v1=i(Ol);lf=o(v1,"self.trackers"),v1.forEach(r),nf=o(er," based on "),Cl=p(er,"CODE",{});var b1=i(Cl);pf=o(b1,"name"),b1.forEach(r),df=o(er," on the main process only."),er.forEach(r),mf=g(Go),b(da.$$.fragment,Go),Go.forEach(r),hf=g(P),Ae=p(P,"DIV",{class:!0});var Vo=i(Ae);b(Zr.$$.fragment,Vo),gf=g(Vo),es=p(Vo,"P",{});var Ni=i(es);ff=o(Ni,"Initializes a run for all trackers stored in "),ql=p(Ni,"CODE",{});var w1=i(ql);uf=o(w1,"self.log_with"),w1.forEach(r),_f=o(Ni,", potentially with starting configurations"),Ni.forEach(r),$f=g(Vo),b(ma.$$.fragment,Vo),Vo.forEach(r),vf=g(P),W=p(P,"DIV",{class:!0});var Ge=i(W);b(ts.$$.fragment,Ge),bf=g(Ge),as=p(Ge,"P",{});var Mi=i(as);wf=o(Mi,`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),Ll=p(Mi,"CODE",{});var j1=i(Ll);jf=o(j1,"torch.distributed.algorithms.join"),j1.forEach(r),yf=o(Mi,`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),Mi.forEach(r),kf=g(Ge),b(ha.$$.fragment,Ge),Af=g(Ge),b(ga.$$.fragment,Ge),Ef=g(Ge),b(fa.$$.fragment,Ge),Ge.forEach(r),xf=g(P),X=p(P,"DIV",{class:!0});var tr=i(X);b(rs.$$.fragment,tr),Pf=g(tr),Sl=p(tr,"P",{});var y1=i(Sl);Df=o(y1,"Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),y1.forEach(r),Tf=g(tr),b(ua.$$.fragment,tr),zf=g(tr),b(_a.$$.fragment,tr),tr.forEach(r),Of=g(P),Z=p(P,"DIV",{class:!0});var ar=i(Z);b(ss.$$.fragment,ar),Cf=g(ar),Il=p(ar,"P",{});var k1=i(Il);qf=o(k1,"Lets the local main process go inside a with block."),k1.forEach(r),Lf=g(ar),Nl=p(ar,"P",{});var A1=i(Nl);Sf=o(A1,"The other processes will enter the with block after the main process exits."),A1.forEach(r),If=g(ar),b($a.$$.fragment,ar),ar.forEach(r),Nf=g(P),Ee=p(P,"DIV",{class:!0});var Wo=i(Ee);b(os.$$.fragment,Wo),Mf=g(Wo),pt=p(Wo,"P",{});var Fo=i(pt);Uf=o(Fo,"Logs "),Ml=p(Fo,"CODE",{});var E1=i(Ml);Rf=o(E1,"values"),E1.forEach(r),Gf=o(Fo," to all stored trackers in "),Ul=p(Fo,"CODE",{});var x1=i(Ul);Vf=o(x1,"self.trackers"),x1.forEach(r),Wf=o(Fo," on the main process only."),Fo.forEach(r),Ff=g(Wo),b(va.$$.fragment,Wo),Wo.forEach(r),Hf=g(P),ee=p(P,"DIV",{class:!0});var rr=i(ee);b(cs.$$.fragment,rr),Yf=g(rr),Rl=p(rr,"P",{});var P1=i(Rl);Bf=o(P1,"Lets the main process go first inside a with block."),P1.forEach(r),Jf=g(rr),Gl=p(rr,"P",{});var D1=i(Gl);Kf=o(D1,"The other processes will enter the with block after the main process exits."),D1.forEach(r),Qf=g(rr),b(ba.$$.fragment,rr),rr.forEach(r),Xf=g(P),te=p(P,"DIV",{class:!0});var sr=i(te);b(ls.$$.fragment,sr),Zf=g(sr),ns=p(sr,"P",{});var Ui=i(ns);eu=o(Ui,`A context manager to disable gradient synchronizations across DDP processes by calling
`),Vl=p(Ui,"CODE",{});var T1=i(Vl);tu=o(T1,"torch.nn.parallel.DistributedDataParallel.no_sync"),T1.forEach(r),au=o(Ui,"."),Ui.forEach(r),ru=g(sr),ps=p(sr,"P",{});var Ri=i(ps);su=o(Ri,"If "),Wl=p(Ri,"CODE",{});var z1=i(Wl);ou=o(z1,"model"),z1.forEach(r),cu=o(Ri," is not in DDP, this context manager does nothing"),Ri.forEach(r),lu=g(sr),b(wa.$$.fragment,sr),sr.forEach(r),nu=g(P),xe=p(P,"DIV",{class:!0});var Ho=i(xe);b(is.$$.fragment,Ho),pu=g(Ho),ds=p(Ho,"P",{});var Gi=i(ds);iu=o(Gi,`A decorator that will run the decorated function on the last process only. Can also be called using the
`),Fl=p(Gi,"CODE",{});var O1=i(Fl);du=o(O1,"PartialState"),O1.forEach(r),mu=o(Gi," class."),Gi.forEach(r),hu=g(Ho),b(ja.$$.fragment,Ho),Ho.forEach(r),gu=g(P),Pe=p(P,"DIV",{class:!0});var Yo=i(Pe);b(ms.$$.fragment,Yo),fu=g(Yo),hs=p(Yo,"P",{});var Vi=i(hs);uu=o(Vi,`A decorator that will run the decorated function on the local main process only. Can also be called using the
`),Hl=p(Vi,"CODE",{});var C1=i(Hl);_u=o(C1,"PartialState"),C1.forEach(r),$u=o(Vi," class."),Vi.forEach(r),vu=g(Yo),b(ya.$$.fragment,Yo),Yo.forEach(r),bu=g(P),De=p(P,"DIV",{class:!0});var Bo=i(De);b(gs.$$.fragment,Bo),wu=g(Bo),fs=p(Bo,"P",{});var Wi=i(fs);ju=o(Wi,`A decorator that will run the decorated function on a given local process index only. Can also be called using
the `),Yl=p(Wi,"CODE",{});var q1=i(Yl);yu=o(q1,"PartialState"),q1.forEach(r),ku=o(Wi," class."),Wi.forEach(r),Au=g(Bo),b(ka.$$.fragment,Bo),Bo.forEach(r),Eu=g(P),Te=p(P,"DIV",{class:!0});var Jo=i(Te);b(us.$$.fragment,Jo),xu=g(Jo),_s=p(Jo,"P",{});var Fi=i(_s);Pu=o(Fi,`A decorator that will run the decorated function on the main process only. Can also be called using the
`),Bl=p(Fi,"CODE",{});var L1=i(Bl);Du=o(L1,"PartialState"),L1.forEach(r),Tu=o(Fi," class."),Fi.forEach(r),zu=g(Jo),b(Aa.$$.fragment,Jo),Jo.forEach(r),Ou=g(P),ze=p(P,"DIV",{class:!0});var Ko=i(ze);b($s.$$.fragment,Ko),Cu=g(Ko),vs=p(Ko,"P",{});var Hi=i(vs);qu=o(Hi,`A decorator that will run the decorated function on a given process index only. Can also be called using the
`),Jl=p(Hi,"CODE",{});var S1=i(Jl);Lu=o(S1,"PartialState"),S1.forEach(r),Su=o(Hi," class."),Hi.forEach(r),Iu=g(Ko),b(Ea.$$.fragment,Ko),Ko.forEach(r),Nu=g(P),Oe=p(P,"DIV",{class:!0});var Qo=i(Oe);b(bs.$$.fragment,Qo),Mu=g(Qo),Kl=p(Qo,"P",{});var I1=i(Kl);Uu=o(I1,`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),I1.forEach(r),Ru=g(Qo),b(xa.$$.fragment,Qo),Qo.forEach(r),Gu=g(P),ae=p(P,"DIV",{class:!0});var or=i(ae);b(ws.$$.fragment,or),Vu=g(or),js=p(or,"P",{});var Yi=i(js);Wu=o(Yi,"Prepare all objects passed in "),Ql=p(Yi,"CODE",{});var N1=i(Ql);Fu=o(N1,"args"),N1.forEach(r),Hu=o(Yi,` for distributed training and mixed precision, then return them in the same
order.`),Yi.forEach(r),Yu=g(or),b(Pa.$$.fragment,or),Bu=g(or),b(Da.$$.fragment,or),or.forEach(r),Ju=g(P),Ce=p(P,"DIV",{class:!0});var Xo=i(Ce);b(ys.$$.fragment,Xo),Ku=g(Xo),ks=p(Xo,"P",{});var Bi=i(ks);Qu=o(Bi,`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),wo=p(Bi,"A",{href:!0});var M1=i(wo);Xu=o(M1,"Accelerator.prepare()"),M1.forEach(r),Zu=o(Bi," instead."),Bi.forEach(r),e_=g(Xo),b(Ta.$$.fragment,Xo),Xo.forEach(r),t_=g(P),qe=p(P,"DIV",{class:!0});var Zo=i(qe);b(As.$$.fragment,Zo),a_=g(Zo),Es=p(Zo,"P",{});var Ji=i(Es);r_=o(Ji,`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),jo=p(Ji,"A",{href:!0});var U1=i(jo);s_=o(U1,"Accelerator.prepare()"),U1.forEach(r),o_=o(Ji," instead."),Ji.forEach(r),c_=g(Zo),b(za.$$.fragment,Zo),Zo.forEach(r),l_=g(P),Le=p(P,"DIV",{class:!0});var ec=i(Le);b(xs.$$.fragment,ec),n_=g(ec),Ps=p(ec,"P",{});var Ki=i(Ps);p_=o(Ki,`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),yo=p(Ki,"A",{href:!0});var R1=i(yo);i_=o(R1,"Accelerator.prepare()"),R1.forEach(r),d_=o(Ki," instead."),Ki.forEach(r),m_=g(ec),b(Oa.$$.fragment,ec),ec.forEach(r),h_=g(P),Se=p(P,"DIV",{class:!0});var tc=i(Se);b(Ds.$$.fragment,tc),g_=g(tc),Ts=p(tc,"P",{});var Qi=i(Ts);f_=o(Qi,`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),ko=p(Qi,"A",{href:!0});var G1=i(ko);u_=o(G1,"Accelerator.prepare()"),G1.forEach(r),__=o(Qi," instead."),Qi.forEach(r),$_=g(tc),b(Ca.$$.fragment,tc),tc.forEach(r),v_=g(P),Ie=p(P,"DIV",{class:!0});var ac=i(Ie);b(zs.$$.fragment,ac),b_=g(ac),Os=p(ac,"P",{});var Xi=i(Os);w_=o(Xi,"Drop in replacement of "),Xl=p(Xi,"CODE",{});var V1=i(Xl);j_=o(V1,"print()"),V1.forEach(r),y_=o(Xi," to only print once per server."),Xi.forEach(r),k_=g(ac),b(qa.$$.fragment,ac),ac.forEach(r),A_=g(P),re=p(P,"DIV",{class:!0});var cr=i(re);b(Cs.$$.fragment,cr),E_=g(cr),it=p(cr,"P",{});var rc=i(it);x_=o(rc,"Reduce the values in "),Zl=p(rc,"EM",{});var W1=i(Zl);P_=o(W1,"tensor"),W1.forEach(r),D_=o(rc," across all processes based on "),en=p(rc,"EM",{});var F1=i(en);T_=o(F1,"reduction"),F1.forEach(r),z_=o(rc,"."),rc.forEach(r),O_=g(cr),tn=p(cr,"P",{});var H1=i(tn);C_=o(H1,`Note:
All processes get the reduced value.`),H1.forEach(r),q_=g(cr),b(La.$$.fragment,cr),cr.forEach(r),L_=g(P),F=p(P,"DIV",{class:!0});var Ve=i(F);b(qs.$$.fragment,Ve),S_=g(Ve),de=p(Ve,"P",{});var lr=i(de);I_=o(lr,"Makes note of "),an=p(lr,"CODE",{});var Y1=i(an);N_=o(Y1,"objects"),Y1.forEach(r),M_=o(lr," and will save or load them in during "),rn=p(lr,"CODE",{});var B1=i(rn);U_=o(B1,"save_state"),B1.forEach(r),R_=o(lr," or "),sn=p(lr,"CODE",{});var J1=i(sn);G_=o(J1,"load_state"),J1.forEach(r),V_=o(lr,"."),lr.forEach(r),W_=g(Ve),on=p(Ve,"P",{});var K1=i(on);F_=o(K1,`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts.`),K1.forEach(r),H_=g(Ve),b(Sa.$$.fragment,Ve),Y_=g(Ve),b(Ia.$$.fragment,Ve),Ve.forEach(r),B_=g(P),M=p(P,"DIV",{class:!0});var oe=i(M);b(Ls.$$.fragment,oe),J_=g(oe),dt=p(oe,"P",{});var sc=i(dt);K_=o(sc,"Registers a pre hook to be run before "),cn=p(sc,"CODE",{});var Q1=i(cn);Q_=o(Q1,"load_checkpoint"),Q1.forEach(r),X_=o(sc," is called in "),Ao=p(sc,"A",{href:!0});var X1=i(Ao);Z_=o(X1,"Accelerator.load_state()"),X1.forEach(r),e$=o(sc,"."),sc.forEach(r),t$=g(oe),ln=p(oe,"P",{});var Z1=i(ln);a$=o(Z1,"The hook should have the following signature:"),Z1.forEach(r),r$=g(oe),nn=p(oe,"P",{});var e2=i(nn);pn=p(e2,"CODE",{});var t2=i(pn);s$=o(t2,"hook(models: List[torch.nn.Module], input_dir: str) -> None"),t2.forEach(r),e2.forEach(r),o$=g(oe),V=p(oe,"P",{});var ce=i(V);c$=o(ce,"The "),dn=p(ce,"CODE",{});var a2=i(dn);l$=o(a2,"models"),a2.forEach(r),n$=o(ce," argument are the models as saved in the accelerator state under "),mn=p(ce,"CODE",{});var r2=i(mn);p$=o(r2,"accelerator._models"),r2.forEach(r),i$=o(ce,`, and the
`),hn=p(ce,"CODE",{});var s2=i(hn);d$=o(s2,"input_dir"),s2.forEach(r),m$=o(ce," argument is the "),gn=p(ce,"CODE",{});var o2=i(gn);h$=o(o2,"input_dir"),o2.forEach(r),g$=o(ce," argument passed to "),Eo=p(ce,"A",{href:!0});var c2=i(Eo);f$=o(c2,"Accelerator.load_state()"),c2.forEach(r),u$=o(ce,"."),ce.forEach(r),_$=g(oe),b(Na.$$.fragment,oe),oe.forEach(r),$$=g(P),U=p(P,"DIV",{class:!0});var le=i(U);b(Ss.$$.fragment,le),v$=g(le),mt=p(le,"P",{});var oc=i(mt);b$=o(oc,"Registers a pre hook to be run before "),fn=p(oc,"CODE",{});var l2=i(fn);w$=o(l2,"save_checkpoint"),l2.forEach(r),j$=o(oc," is called in "),xo=p(oc,"A",{href:!0});var n2=i(xo);y$=o(n2,"Accelerator.save_state()"),n2.forEach(r),k$=o(oc,"."),oc.forEach(r),A$=g(le),un=p(le,"P",{});var p2=i(un);E$=o(p2,"The hook should have the following signature:"),p2.forEach(r),x$=g(le),_n=p(le,"P",{});var i2=i(_n);$n=p(i2,"CODE",{});var d2=i($n);P$=o(d2,"hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),d2.forEach(r),i2.forEach(r),D$=g(le),S=p(le,"P",{});var G=i(S);T$=o(G,"The "),vn=p(G,"CODE",{});var m2=i(vn);z$=o(m2,"models"),m2.forEach(r),O$=o(G," argument are the models as saved in the accelerator state under "),bn=p(G,"CODE",{});var h2=i(bn);C$=o(h2,"accelerator._models"),h2.forEach(r),q$=o(G,", "),wn=p(G,"CODE",{});var g2=i(wn);L$=o(g2,"weigths"),g2.forEach(r),S$=o(G,`
argument are the state dicts of the `),jn=p(G,"CODE",{});var f2=i(jn);I$=o(f2,"models"),f2.forEach(r),N$=o(G,", and the "),yn=p(G,"CODE",{});var u2=i(yn);M$=o(u2,"input_dir"),u2.forEach(r),U$=o(G," argument is the "),kn=p(G,"CODE",{});var _2=i(kn);R$=o(_2,"input_dir"),_2.forEach(r),G$=o(G,` argument passed
to `),Po=p(G,"A",{href:!0});var $2=i(Po);V$=o($2,"Accelerator.load_state()"),$2.forEach(r),W$=o(G,"."),G.forEach(r),F$=g(le),b(Ma.$$.fragment,le),le.forEach(r),H$=g(P),Ne=p(P,"DIV",{class:!0});var cc=i(Ne);b(Is.$$.fragment,cc),Y$=g(cc),Ns=p(cc,"P",{});var Zi=i(Ns);B$=o(Zi,"Save the object passed to disk once per machine. Use in place of "),An=p(Zi,"CODE",{});var v2=i(An);J$=o(v2,"torch.save"),v2.forEach(r),K$=o(Zi,"."),Zi.forEach(r),Q$=g(cc),b(Ua.$$.fragment,cc),cc.forEach(r),X$=g(P),R=p(P,"DIV",{class:!0});var ne=i(R);b(Ms.$$.fragment,ne),Z$=g(ne),En=p(ne,"P",{});var b2=i(En);ev=o(b2,"Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),b2.forEach(r),tv=g(ne),N=p(ne,"P",{});var H=i(N);av=o(H,"If a "),xn=p(H,"CODE",{});var w2=i(xn);rv=o(w2,"ProjectConfiguration"),w2.forEach(r),sv=o(H," was passed to the "),Pn=p(H,"CODE",{});var j2=i(Pn);ov=o(j2,"Accelerator"),j2.forEach(r),cv=o(H," object with "),Dn=p(H,"CODE",{});var y2=i(Dn);lv=o(y2,"automatic_checkpoint_naming"),y2.forEach(r),nv=o(H,` enabled
then checkpoints will be saved to `),Tn=p(H,"CODE",{});var k2=i(Tn);pv=o(k2,"self.project_dir/checkpoints"),k2.forEach(r),iv=o(H,`. If the number of current saves is greater
than `),zn=p(H,"CODE",{});var A2=i(zn);dv=o(A2,"total_limit"),A2.forEach(r),mv=o(H,` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),On=p(H,"CODE",{});var E2=i(On);hv=o(E2,"checkpoint_<iteration>"),E2.forEach(r),gv=o(H,"."),H.forEach(r),fv=g(ne),Us=p(ne,"P",{});var ed=i(Us);uv=o(ed,"Otherwise they are just saved to "),Cn=p(ed,"CODE",{});var x2=i(Cn);_v=o(x2,"output_dir"),x2.forEach(r),$v=o(ed,"."),ed.forEach(r),vv=g(ne),b(Ra.$$.fragment,ne),bv=g(ne),b(Ga.$$.fragment,ne),ne.forEach(r),wv=g(P),Me=p(P,"DIV",{class:!0});var lc=i(Me);b(Rs.$$.fragment,lc),jv=g(lc),ht=p(lc,"P",{});var nc=i(ht);yv=o(nc,"Creates a new "),qn=p(nc,"CODE",{});var P2=i(qn);kv=o(P2,"torch.utils.data.DataLoader"),P2.forEach(r),Av=o(nc," that will efficiently skip the first "),Ln=p(nc,"CODE",{});var D2=i(Ln);Ev=o(D2,"num_batches"),D2.forEach(r),xv=o(nc,"."),nc.forEach(r),Pv=g(lc),b(Va.$$.fragment,lc),lc.forEach(r),Dv=g(P),se=p(P,"DIV",{class:!0});var nr=i(se);b(Gs.$$.fragment,nr),Tv=g(nr),Sn=p(nr,"P",{});var T2=i(Sn);zv=o(T2,"Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),T2.forEach(r),Ov=g(nr),Wa=p(nr,"P",{});var Dp=i(Wa);Cv=o(Dp,"Likely should be called through "),Fa=p(Dp,"A",{href:!0});var td=i(Fa);qv=o(td,"Accelerator.clip"),In=p(td,"EM",{});var z2=i(In);Lv=o(z2,"grad_norm"),z2.forEach(r),Sv=o(td,"()"),td.forEach(r),Iv=o(Dp," or "),Ha=p(Dp,"A",{href:!0});var ad=i(Ha);Nv=o(ad,"Accelerator.clip"),Nn=p(ad,"EM",{});var O2=i(Nn);Mv=o(O2,"grad_value"),O2.forEach(r),Uv=o(ad,"()"),ad.forEach(r),Dp.forEach(r),Rv=g(nr),b(Ya.$$.fragment,nr),nr.forEach(r),Gv=g(P),Ue=p(P,"DIV",{class:!0});var pc=i(Ue);b(Vs.$$.fragment,pc),Vv=g(pc),gt=p(pc,"P",{});var ic=i(gt);Wv=o(ic,"Unwraps the "),Mn=p(ic,"CODE",{});var C2=i(Mn);Fv=o(C2,"model"),C2.forEach(r),Hv=o(ic," from the additional layer possible added by "),Do=p(ic,"A",{href:!0});var q2=i(Do);Yv=o(q2,"prepare()"),q2.forEach(r),Bv=o(ic,`. Useful before saving
the model.`),ic.forEach(r),Jv=g(pc),b(Ba.$$.fragment,pc),pc.forEach(r),Kv=g(P),Re=p(P,"DIV",{class:!0});var dc=i(Re);b(Ws.$$.fragment,dc),Qv=g(dc),Un=p(dc,"P",{});var L2=i(Un);Xv=o(L2,`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),L2.forEach(r),Zv=g(dc),b(Ja.$$.fragment,dc),dc.forEach(r),P.forEach(r),this.h()},h(){A(c,"name","hf:doc:metadata"),A(c,"content",JSON.stringify(Iw)),A(l,"id","accelerator"),A(l,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(l,"href","#accelerator"),A(m,"class","relative group"),A(I,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator"),A(vt,"id","quick-adaptation-of-your-code"),A(vt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(vt,"href","#quick-adaptation-of-your-code"),A(Ye,"class","relative group"),A(oo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator"),A(co,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(no,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.gather"),A(Je,"start","4"),A(kt,"id","advanced-recommendations"),A(kt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(kt,"href","#advanced-recommendations"),A(Ke,"class","relative group"),A(At,"id","printing"),A(At,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(At,"href","#printing"),A(Qe,"class","relative group"),A(po,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.print"),A(Et,"id","executing-processes"),A(Et,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Et,"href","#executing-processes"),A(Ze,"class","relative group"),A(xt,"id","once-on-a-single-server"),A(xt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(xt,"href","#once-on-a-single-server"),A(et,"class","relative group"),A(io,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.on_local_main_process"),A(Tt,"id","only-ever-once-across-all-servers"),A(Tt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Tt,"href","#only-ever-once-across-all-servers"),A(tt,"class","relative group"),A(mo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.on_main_process"),A(Ct,"id","on-specific-processes"),A(Ct,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Ct,"href","#on-specific-processes"),A(at,"class","relative group"),A(qt,"id","synchronicity-control"),A(qt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(qt,"href","#synchronicity-control"),A(rt,"class","relative group"),A(go,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.wait_for_everyone"),A(St,"id","saving-and-loading"),A(St,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(St,"href","#saving-and-loading"),A(st,"class","relative group"),A(fo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.unwrap_model"),A(uo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save"),A(Nt,"id","operations"),A(Nt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Nt,"href","#operations"),A(ot,"class","relative group"),A(Mt,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),A(Ut,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),A(Rt,"id","gradient-accumulation"),A(Rt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Rt,"href","#gradient-accumulation"),A(ct,"class","relative group"),A(_o,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.accumulate"),A(Vt,"id","accelerate.Accelerator"),A(Vt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Vt,"href","#accelerate.Accelerator"),A(lt,"class","relative group"),A($o,"href","/docs/accelerate/main/en/package_reference/utilities#accelerate.DistributedType"),A(vo,"href","/docs/accelerate/main/en/package_reference/state#accelerate.state.AcceleratorState"),A(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(bo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(De,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(wo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(jo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(yo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ko,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ao,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state"),A(Eo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state"),A(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(xo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state"),A(Po,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state"),A(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Fa,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),A(Ha,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),A(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Do,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(a,_){e(document.head,c),$(a,u,_),$(a,m,_),e(m,l),e(l,f),w(t,f,null),e(m,d),e(m,q),e(q,Fe),$(a,$t,_),$(a,J,_),e(J,He),e(J,I),e(I,ao),e(J,ro),$(a,pr,_),$(a,Ye,_),e(Ye,vt),e(vt,mc),w(ir,mc,null),e(Ye,rd),e(Ye,hc),e(hc,sd),$(a,Tp,_),$(a,so,_),e(so,od),$(a,zp,_),$(a,he,_),e(he,Be),e(Be,cd),e(Be,oo),e(oo,ld),e(Be,nd),e(Be,gc),e(gc,pd),e(Be,id),e(he,dd),e(he,dr),e(dr,md),e(dr,co),e(co,hd),e(dr,gd),e(he,fd),e(he,pe),e(pe,ud),e(pe,fc),e(fc,_d),e(pe,$d),e(pe,uc),e(uc,vd),e(pe,bd),e(pe,_c),e(_c,wd),e(pe,jd),$(a,Op,_),w(bt,a,_),$(a,Cp,_),$(a,Je,_),e(Je,wt),e(wt,yd),e(wt,$c),e($c,kd),e(wt,Ad),e(wt,vc),e(vc,Ed),e(Je,xd),e(Je,lo),e(lo,Pd),e(lo,no),e(no,Dd),$(a,qp,_),w(jt,a,_),$(a,Lp,_),$(a,yt,_),e(yt,Td),e(yt,bc),e(bc,zd),e(yt,Od),$(a,Sp,_),$(a,Ke,_),e(Ke,kt),e(kt,wc),w(mr,wc,null),e(Ke,Cd),e(Ke,jc),e(jc,qd),$(a,Ip,_),$(a,Qe,_),e(Qe,At),e(At,yc),w(hr,yc,null),e(Qe,Ld),e(Qe,kc),e(kc,Sd),$(a,Np,_),$(a,Xe,_),e(Xe,Ac),e(Ac,Id),e(Xe,Nd),e(Xe,po),e(po,Md),e(Xe,Ud),$(a,Mp,_),w(gr,a,_),$(a,Up,_),$(a,Ze,_),e(Ze,Et),e(Et,Ec),w(fr,Ec,null),e(Ze,Rd),e(Ze,xc),e(xc,Gd),$(a,Rp,_),$(a,et,_),e(et,xt),e(xt,Pc),w(ur,Pc,null),e(et,Vd),e(et,Dc),e(Dc,Wd),$(a,Gp,_),$(a,Pt,_),e(Pt,Fd),e(Pt,Tc),e(Tc,Hd),e(Pt,Yd),$(a,Vp,_),w(_r,a,_),$(a,Wp,_),$(a,Dt,_),e(Dt,Bd),e(Dt,io),e(io,Jd),e(Dt,Kd),$(a,Fp,_),w($r,a,_),$(a,Hp,_),$(a,tt,_),e(tt,Tt),e(Tt,zc),w(vr,zc,null),e(tt,Qd),e(tt,Oc),e(Oc,Xd),$(a,Yp,_),$(a,zt,_),e(zt,Zd),e(zt,Cc),e(Cc,em),e(zt,tm),$(a,Bp,_),w(br,a,_),$(a,Jp,_),$(a,Ot,_),e(Ot,am),e(Ot,mo),e(mo,rm),e(Ot,sm),$(a,Kp,_),w(wr,a,_),$(a,Qp,_),$(a,at,_),e(at,Ct),e(Ct,qc),w(jr,qc,null),e(at,om),e(at,Lc),e(Lc,cm),$(a,Xp,_),$(a,ho,_),e(ho,lm),$(a,Zp,_),w(yr,a,_),$(a,ei,_),w(kr,a,_),$(a,ti,_),$(a,rt,_),e(rt,qt),e(qt,Sc),w(Ar,Sc,null),e(rt,nm),e(rt,Ic),e(Ic,pm),$(a,ai,_),$(a,Lt,_),e(Lt,im),e(Lt,go),e(go,dm),e(Lt,mm),$(a,ri,_),$(a,st,_),e(st,St),e(St,Nc),w(Er,Nc,null),e(st,hm),e(st,Mc),e(Mc,gm),$(a,si,_),$(a,It,_),e(It,fm),e(It,fo),e(fo,um),e(It,_m),$(a,oi,_),w(xr,a,_),$(a,ci,_),$(a,ge,_),e(ge,$m),e(ge,uo),e(uo,vm),e(ge,bm),e(ge,Uc),e(Uc,wm),e(ge,jm),$(a,li,_),w(Pr,a,_),$(a,ni,_),$(a,ot,_),e(ot,Nt),e(Nt,Rc),w(Dr,Rc,null),e(ot,ym),e(ot,Gc),e(Gc,km),$(a,pi,_),$(a,Y,_),e(Y,Am),e(Y,Mt),e(Mt,Em),e(Mt,Vc),e(Vc,xm),e(Mt,Pm),e(Y,Dm),e(Y,Wc),e(Wc,Tm),e(Y,zm),e(Y,Ut),e(Ut,Om),e(Ut,Fc),e(Fc,Cm),e(Ut,qm),e(Y,Lm),e(Y,Hc),e(Hc,Sm),$(a,ii,_),$(a,ct,_),e(ct,Rt),e(Rt,Yc),w(Tr,Yc,null),e(ct,Im),e(ct,Bc),e(Bc,Nm),$(a,di,_),$(a,Gt,_),e(Gt,Mm),e(Gt,_o),e(_o,Um),e(Gt,Rm),$(a,mi,_),w(zr,a,_),$(a,hi,_),$(a,lt,_),e(lt,Vt),e(Vt,Jc),w(Or,Jc,null),e(lt,Gm),e(lt,Kc),e(Kc,Vm),$(a,gi,_),$(a,x,_),w(Cr,x,null),e(x,Wm),e(x,Qc),e(Qc,Fm),e(x,Hm),e(x,Xc),e(Xc,Zc),e(Zc,Ym),e(x,Bm),e(x,C),e(C,Wt),e(Wt,el),e(el,Jm),e(Wt,Km),e(Wt,tl),e(tl,Qm),e(Wt,Xm),e(C,Zm),e(C,Ft),e(Ft,al),e(al,eh),e(Ft,th),e(Ft,$o),e($o,ah),e(Ft,rh),e(C,sh),e(C,Ht),e(Ht,rl),e(rl,oh),e(Ht,ch),e(Ht,sl),e(sl,lh),e(Ht,nh),e(C,ph),e(C,Yt),e(Yt,ol),e(ol,ih),e(Yt,dh),e(Yt,cl),e(cl,mh),e(Yt,hh),e(C,gh),e(C,Bt),e(Bt,ll),e(ll,fh),e(Bt,uh),e(Bt,nl),e(nl,_h),e(Bt,$h),e(C,vh),e(C,Jt),e(Jt,pl),e(pl,bh),e(Jt,wh),e(Jt,il),e(il,jh),e(Jt,yh),e(C,kh),e(C,Kt),e(Kt,dl),e(dl,Ah),e(Kt,Eh),e(Kt,ml),e(ml,xh),e(Kt,Ph),e(C,Dh),e(C,Qt),e(Qt,hl),e(hl,Th),e(Qt,zh),e(Qt,vo),e(vo,Oh),e(Qt,Ch),e(C,qh),e(C,Xt),e(Xt,gl),e(gl,Lh),e(Xt,Sh),e(Xt,fl),e(fl,Ih),e(Xt,Nh),e(C,Mh),e(C,Zt),e(Zt,ul),e(ul,Uh),e(Zt,Rh),e(Zt,_l),e(_l,Gh),e(Zt,Vh),e(x,Wh),e(x,fe),w(qr,fe,null),e(fe,Fh),e(fe,$l),e($l,Hh),e(fe,Yh),w(ea,fe,null),e(x,Bh),e(x,ue),w(Lr,ue,null),e(ue,Jh),e(ue,vl),e(vl,Kh),e(ue,Qh),w(ta,ue,null),e(x,Xh),e(x,K),w(Sr,K,null),e(K,Zh),e(K,nt),e(nt,eg),e(nt,bl),e(bl,tg),e(nt,ag),e(nt,wl),e(wl,rg),e(nt,sg),e(K,og),e(K,Ir),e(Ir,cg),e(Ir,jl),e(jl,lg),e(Ir,ng),e(K,pg),w(aa,K,null),e(x,ig),e(x,_e),w(Nr,_e,null),e(_e,dg),e(_e,Mr),e(Mr,mg),e(Mr,yl),e(yl,hg),e(Mr,gg),e(_e,fg),w(ra,_e,null),e(x,ug),e(x,$e),w(Ur,$e,null),e($e,_g),e($e,Rr),e(Rr,$g),e(Rr,kl),e(kl,vg),e(Rr,bg),e($e,wg),w(sa,$e,null),e(x,jg),e(x,ve),w(Gr,ve,null),e(ve,yg),e(ve,Vr),e(Vr,kg),e(Vr,Al),e(Al,Ag),e(Vr,Eg),e(ve,xg),w(oa,ve,null),e(x,Pg),e(x,be),w(Wr,be,null),e(be,Dg),e(be,El),e(El,Tg),e(be,zg),w(ca,be,null),e(x,Og),e(x,we),w(Fr,we,null),e(we,Cg),e(we,xl),e(xl,qg),e(we,Lg),w(la,we,null),e(x,Sg),e(x,Q),w(Hr,Q,null),e(Q,Ig),e(Q,Yr),e(Yr,Ng),e(Yr,Pl),e(Pl,Mg),e(Yr,Ug),e(Q,Rg),e(Q,Dl),e(Dl,Gg),e(Q,Vg),w(na,Q,null),e(x,Wg),e(x,je),w(Br,je,null),e(je,Fg),e(je,Jr),e(Jr,Hg),e(Jr,Tl),e(Tl,Yg),e(Jr,Bg),e(je,Jg),w(pa,je,null),e(x,Kg),e(x,ye),w(Kr,ye,null),e(ye,Qg),e(ye,Qr),e(Qr,Xg),e(Qr,bo),e(bo,Zg),e(Qr,ef),e(ye,tf),w(ia,ye,null),e(x,af),e(x,ke),w(Xr,ke,null),e(ke,rf),e(ke,ie),e(ie,sf),e(ie,zl),e(zl,of),e(ie,cf),e(ie,Ol),e(Ol,lf),e(ie,nf),e(ie,Cl),e(Cl,pf),e(ie,df),e(ke,mf),w(da,ke,null),e(x,hf),e(x,Ae),w(Zr,Ae,null),e(Ae,gf),e(Ae,es),e(es,ff),e(es,ql),e(ql,uf),e(es,_f),e(Ae,$f),w(ma,Ae,null),e(x,vf),e(x,W),w(ts,W,null),e(W,bf),e(W,as),e(as,wf),e(as,Ll),e(Ll,jf),e(as,yf),e(W,kf),w(ha,W,null),e(W,Af),w(ga,W,null),e(W,Ef),w(fa,W,null),e(x,xf),e(x,X),w(rs,X,null),e(X,Pf),e(X,Sl),e(Sl,Df),e(X,Tf),w(ua,X,null),e(X,zf),w(_a,X,null),e(x,Of),e(x,Z),w(ss,Z,null),e(Z,Cf),e(Z,Il),e(Il,qf),e(Z,Lf),e(Z,Nl),e(Nl,Sf),e(Z,If),w($a,Z,null),e(x,Nf),e(x,Ee),w(os,Ee,null),e(Ee,Mf),e(Ee,pt),e(pt,Uf),e(pt,Ml),e(Ml,Rf),e(pt,Gf),e(pt,Ul),e(Ul,Vf),e(pt,Wf),e(Ee,Ff),w(va,Ee,null),e(x,Hf),e(x,ee),w(cs,ee,null),e(ee,Yf),e(ee,Rl),e(Rl,Bf),e(ee,Jf),e(ee,Gl),e(Gl,Kf),e(ee,Qf),w(ba,ee,null),e(x,Xf),e(x,te),w(ls,te,null),e(te,Zf),e(te,ns),e(ns,eu),e(ns,Vl),e(Vl,tu),e(ns,au),e(te,ru),e(te,ps),e(ps,su),e(ps,Wl),e(Wl,ou),e(ps,cu),e(te,lu),w(wa,te,null),e(x,nu),e(x,xe),w(is,xe,null),e(xe,pu),e(xe,ds),e(ds,iu),e(ds,Fl),e(Fl,du),e(ds,mu),e(xe,hu),w(ja,xe,null),e(x,gu),e(x,Pe),w(ms,Pe,null),e(Pe,fu),e(Pe,hs),e(hs,uu),e(hs,Hl),e(Hl,_u),e(hs,$u),e(Pe,vu),w(ya,Pe,null),e(x,bu),e(x,De),w(gs,De,null),e(De,wu),e(De,fs),e(fs,ju),e(fs,Yl),e(Yl,yu),e(fs,ku),e(De,Au),w(ka,De,null),e(x,Eu),e(x,Te),w(us,Te,null),e(Te,xu),e(Te,_s),e(_s,Pu),e(_s,Bl),e(Bl,Du),e(_s,Tu),e(Te,zu),w(Aa,Te,null),e(x,Ou),e(x,ze),w($s,ze,null),e(ze,Cu),e(ze,vs),e(vs,qu),e(vs,Jl),e(Jl,Lu),e(vs,Su),e(ze,Iu),w(Ea,ze,null),e(x,Nu),e(x,Oe),w(bs,Oe,null),e(Oe,Mu),e(Oe,Kl),e(Kl,Uu),e(Oe,Ru),w(xa,Oe,null),e(x,Gu),e(x,ae),w(ws,ae,null),e(ae,Vu),e(ae,js),e(js,Wu),e(js,Ql),e(Ql,Fu),e(js,Hu),e(ae,Yu),w(Pa,ae,null),e(ae,Bu),w(Da,ae,null),e(x,Ju),e(x,Ce),w(ys,Ce,null),e(Ce,Ku),e(Ce,ks),e(ks,Qu),e(ks,wo),e(wo,Xu),e(ks,Zu),e(Ce,e_),w(Ta,Ce,null),e(x,t_),e(x,qe),w(As,qe,null),e(qe,a_),e(qe,Es),e(Es,r_),e(Es,jo),e(jo,s_),e(Es,o_),e(qe,c_),w(za,qe,null),e(x,l_),e(x,Le),w(xs,Le,null),e(Le,n_),e(Le,Ps),e(Ps,p_),e(Ps,yo),e(yo,i_),e(Ps,d_),e(Le,m_),w(Oa,Le,null),e(x,h_),e(x,Se),w(Ds,Se,null),e(Se,g_),e(Se,Ts),e(Ts,f_),e(Ts,ko),e(ko,u_),e(Ts,__),e(Se,$_),w(Ca,Se,null),e(x,v_),e(x,Ie),w(zs,Ie,null),e(Ie,b_),e(Ie,Os),e(Os,w_),e(Os,Xl),e(Xl,j_),e(Os,y_),e(Ie,k_),w(qa,Ie,null),e(x,A_),e(x,re),w(Cs,re,null),e(re,E_),e(re,it),e(it,x_),e(it,Zl),e(Zl,P_),e(it,D_),e(it,en),e(en,T_),e(it,z_),e(re,O_),e(re,tn),e(tn,C_),e(re,q_),w(La,re,null),e(x,L_),e(x,F),w(qs,F,null),e(F,S_),e(F,de),e(de,I_),e(de,an),e(an,N_),e(de,M_),e(de,rn),e(rn,U_),e(de,R_),e(de,sn),e(sn,G_),e(de,V_),e(F,W_),e(F,on),e(on,F_),e(F,H_),w(Sa,F,null),e(F,Y_),w(Ia,F,null),e(x,B_),e(x,M),w(Ls,M,null),e(M,J_),e(M,dt),e(dt,K_),e(dt,cn),e(cn,Q_),e(dt,X_),e(dt,Ao),e(Ao,Z_),e(dt,e$),e(M,t$),e(M,ln),e(ln,a$),e(M,r$),e(M,nn),e(nn,pn),e(pn,s$),e(M,o$),e(M,V),e(V,c$),e(V,dn),e(dn,l$),e(V,n$),e(V,mn),e(mn,p$),e(V,i$),e(V,hn),e(hn,d$),e(V,m$),e(V,gn),e(gn,h$),e(V,g$),e(V,Eo),e(Eo,f$),e(V,u$),e(M,_$),w(Na,M,null),e(x,$$),e(x,U),w(Ss,U,null),e(U,v$),e(U,mt),e(mt,b$),e(mt,fn),e(fn,w$),e(mt,j$),e(mt,xo),e(xo,y$),e(mt,k$),e(U,A$),e(U,un),e(un,E$),e(U,x$),e(U,_n),e(_n,$n),e($n,P$),e(U,D$),e(U,S),e(S,T$),e(S,vn),e(vn,z$),e(S,O$),e(S,bn),e(bn,C$),e(S,q$),e(S,wn),e(wn,L$),e(S,S$),e(S,jn),e(jn,I$),e(S,N$),e(S,yn),e(yn,M$),e(S,U$),e(S,kn),e(kn,R$),e(S,G$),e(S,Po),e(Po,V$),e(S,W$),e(U,F$),w(Ma,U,null),e(x,H$),e(x,Ne),w(Is,Ne,null),e(Ne,Y$),e(Ne,Ns),e(Ns,B$),e(Ns,An),e(An,J$),e(Ns,K$),e(Ne,Q$),w(Ua,Ne,null),e(x,X$),e(x,R),w(Ms,R,null),e(R,Z$),e(R,En),e(En,ev),e(R,tv),e(R,N),e(N,av),e(N,xn),e(xn,rv),e(N,sv),e(N,Pn),e(Pn,ov),e(N,cv),e(N,Dn),e(Dn,lv),e(N,nv),e(N,Tn),e(Tn,pv),e(N,iv),e(N,zn),e(zn,dv),e(N,mv),e(N,On),e(On,hv),e(N,gv),e(R,fv),e(R,Us),e(Us,uv),e(Us,Cn),e(Cn,_v),e(Us,$v),e(R,vv),w(Ra,R,null),e(R,bv),w(Ga,R,null),e(x,wv),e(x,Me),w(Rs,Me,null),e(Me,jv),e(Me,ht),e(ht,yv),e(ht,qn),e(qn,kv),e(ht,Av),e(ht,Ln),e(Ln,Ev),e(ht,xv),e(Me,Pv),w(Va,Me,null),e(x,Dv),e(x,se),w(Gs,se,null),e(se,Tv),e(se,Sn),e(Sn,zv),e(se,Ov),e(se,Wa),e(Wa,Cv),e(Wa,Fa),e(Fa,qv),e(Fa,In),e(In,Lv),e(Fa,Sv),e(Wa,Iv),e(Wa,Ha),e(Ha,Nv),e(Ha,Nn),e(Nn,Mv),e(Ha,Uv),e(se,Rv),w(Ya,se,null),e(x,Gv),e(x,Ue),w(Vs,Ue,null),e(Ue,Vv),e(Ue,gt),e(gt,Wv),e(gt,Mn),e(Mn,Fv),e(gt,Hv),e(gt,Do),e(Do,Yv),e(gt,Bv),e(Ue,Jv),w(Ba,Ue,null),e(x,Kv),e(x,Re),w(Ws,Re,null),e(Re,Qv),e(Re,Un),e(Un,Xv),e(Re,Zv),w(Ja,Re,null),fi=!0},p(a,[_]){const Fs={};_&2&&(Fs.$$scope={dirty:_,ctx:a}),bt.$set(Fs);const Rn={};_&2&&(Rn.$$scope={dirty:_,ctx:a}),jt.$set(Rn);const Gn={};_&2&&(Gn.$$scope={dirty:_,ctx:a}),ea.$set(Gn);const Vn={};_&2&&(Vn.$$scope={dirty:_,ctx:a}),ta.$set(Vn);const Hs={};_&2&&(Hs.$$scope={dirty:_,ctx:a}),aa.$set(Hs);const Wn={};_&2&&(Wn.$$scope={dirty:_,ctx:a}),ra.$set(Wn);const Ys={};_&2&&(Ys.$$scope={dirty:_,ctx:a}),sa.$set(Ys);const Fn={};_&2&&(Fn.$$scope={dirty:_,ctx:a}),oa.$set(Fn);const Hn={};_&2&&(Hn.$$scope={dirty:_,ctx:a}),ca.$set(Hn);const Yn={};_&2&&(Yn.$$scope={dirty:_,ctx:a}),la.$set(Yn);const Bn={};_&2&&(Bn.$$scope={dirty:_,ctx:a}),na.$set(Bn);const ft={};_&2&&(ft.$$scope={dirty:_,ctx:a}),pa.$set(ft);const ut={};_&2&&(ut.$$scope={dirty:_,ctx:a}),ia.$set(ut);const Jn={};_&2&&(Jn.$$scope={dirty:_,ctx:a}),da.$set(Jn);const Kn={};_&2&&(Kn.$$scope={dirty:_,ctx:a}),ma.$set(Kn);const Bs={};_&2&&(Bs.$$scope={dirty:_,ctx:a}),ha.$set(Bs);const Qn={};_&2&&(Qn.$$scope={dirty:_,ctx:a}),ga.$set(Qn);const me={};_&2&&(me.$$scope={dirty:_,ctx:a}),fa.$set(me);const Xn={};_&2&&(Xn.$$scope={dirty:_,ctx:a}),ua.$set(Xn);const Zn={};_&2&&(Zn.$$scope={dirty:_,ctx:a}),_a.$set(Zn);const ep={};_&2&&(ep.$$scope={dirty:_,ctx:a}),$a.$set(ep);const Js={};_&2&&(Js.$$scope={dirty:_,ctx:a}),va.$set(Js);const Ka={};_&2&&(Ka.$$scope={dirty:_,ctx:a}),ba.$set(Ka);const tp={};_&2&&(tp.$$scope={dirty:_,ctx:a}),wa.$set(tp);const ap={};_&2&&(ap.$$scope={dirty:_,ctx:a}),ja.$set(ap);const To={};_&2&&(To.$$scope={dirty:_,ctx:a}),ya.$set(To);const rp={};_&2&&(rp.$$scope={dirty:_,ctx:a}),ka.$set(rp);const Ks={};_&2&&(Ks.$$scope={dirty:_,ctx:a}),Aa.$set(Ks);const sp={};_&2&&(sp.$$scope={dirty:_,ctx:a}),Ea.$set(sp);const Qs={};_&2&&(Qs.$$scope={dirty:_,ctx:a}),xa.$set(Qs);const op={};_&2&&(op.$$scope={dirty:_,ctx:a}),Pa.$set(op);const cp={};_&2&&(cp.$$scope={dirty:_,ctx:a}),Da.$set(cp);const lp={};_&2&&(lp.$$scope={dirty:_,ctx:a}),Ta.$set(lp);const Xs={};_&2&&(Xs.$$scope={dirty:_,ctx:a}),za.$set(Xs);const np={};_&2&&(np.$$scope={dirty:_,ctx:a}),Oa.$set(np);const pp={};_&2&&(pp.$$scope={dirty:_,ctx:a}),Ca.$set(pp);const ip={};_&2&&(ip.$$scope={dirty:_,ctx:a}),qa.$set(ip);const Qa={};_&2&&(Qa.$$scope={dirty:_,ctx:a}),La.$set(Qa);const dp={};_&2&&(dp.$$scope={dirty:_,ctx:a}),Sa.$set(dp);const mp={};_&2&&(mp.$$scope={dirty:_,ctx:a}),Ia.$set(mp);const Zs={};_&2&&(Zs.$$scope={dirty:_,ctx:a}),Na.$set(Zs);const hp={};_&2&&(hp.$$scope={dirty:_,ctx:a}),Ma.$set(hp);const gp={};_&2&&(gp.$$scope={dirty:_,ctx:a}),Ua.$set(gp);const fp={};_&2&&(fp.$$scope={dirty:_,ctx:a}),Ra.$set(fp);const eo={};_&2&&(eo.$$scope={dirty:_,ctx:a}),Ga.$set(eo);const up={};_&2&&(up.$$scope={dirty:_,ctx:a}),Va.$set(up);const _p={};_&2&&(_p.$$scope={dirty:_,ctx:a}),Ya.$set(_p);const $p={};_&2&&($p.$$scope={dirty:_,ctx:a}),Ba.$set($p);const to={};_&2&&(to.$$scope={dirty:_,ctx:a}),Ja.$set(to)},i(a){fi||(j(t.$$.fragment,a),j(ir.$$.fragment,a),j(bt.$$.fragment,a),j(jt.$$.fragment,a),j(mr.$$.fragment,a),j(hr.$$.fragment,a),j(gr.$$.fragment,a),j(fr.$$.fragment,a),j(ur.$$.fragment,a),j(_r.$$.fragment,a),j($r.$$.fragment,a),j(vr.$$.fragment,a),j(br.$$.fragment,a),j(wr.$$.fragment,a),j(jr.$$.fragment,a),j(yr.$$.fragment,a),j(kr.$$.fragment,a),j(Ar.$$.fragment,a),j(Er.$$.fragment,a),j(xr.$$.fragment,a),j(Pr.$$.fragment,a),j(Dr.$$.fragment,a),j(Tr.$$.fragment,a),j(zr.$$.fragment,a),j(Or.$$.fragment,a),j(Cr.$$.fragment,a),j(qr.$$.fragment,a),j(ea.$$.fragment,a),j(Lr.$$.fragment,a),j(ta.$$.fragment,a),j(Sr.$$.fragment,a),j(aa.$$.fragment,a),j(Nr.$$.fragment,a),j(ra.$$.fragment,a),j(Ur.$$.fragment,a),j(sa.$$.fragment,a),j(Gr.$$.fragment,a),j(oa.$$.fragment,a),j(Wr.$$.fragment,a),j(ca.$$.fragment,a),j(Fr.$$.fragment,a),j(la.$$.fragment,a),j(Hr.$$.fragment,a),j(na.$$.fragment,a),j(Br.$$.fragment,a),j(pa.$$.fragment,a),j(Kr.$$.fragment,a),j(ia.$$.fragment,a),j(Xr.$$.fragment,a),j(da.$$.fragment,a),j(Zr.$$.fragment,a),j(ma.$$.fragment,a),j(ts.$$.fragment,a),j(ha.$$.fragment,a),j(ga.$$.fragment,a),j(fa.$$.fragment,a),j(rs.$$.fragment,a),j(ua.$$.fragment,a),j(_a.$$.fragment,a),j(ss.$$.fragment,a),j($a.$$.fragment,a),j(os.$$.fragment,a),j(va.$$.fragment,a),j(cs.$$.fragment,a),j(ba.$$.fragment,a),j(ls.$$.fragment,a),j(wa.$$.fragment,a),j(is.$$.fragment,a),j(ja.$$.fragment,a),j(ms.$$.fragment,a),j(ya.$$.fragment,a),j(gs.$$.fragment,a),j(ka.$$.fragment,a),j(us.$$.fragment,a),j(Aa.$$.fragment,a),j($s.$$.fragment,a),j(Ea.$$.fragment,a),j(bs.$$.fragment,a),j(xa.$$.fragment,a),j(ws.$$.fragment,a),j(Pa.$$.fragment,a),j(Da.$$.fragment,a),j(ys.$$.fragment,a),j(Ta.$$.fragment,a),j(As.$$.fragment,a),j(za.$$.fragment,a),j(xs.$$.fragment,a),j(Oa.$$.fragment,a),j(Ds.$$.fragment,a),j(Ca.$$.fragment,a),j(zs.$$.fragment,a),j(qa.$$.fragment,a),j(Cs.$$.fragment,a),j(La.$$.fragment,a),j(qs.$$.fragment,a),j(Sa.$$.fragment,a),j(Ia.$$.fragment,a),j(Ls.$$.fragment,a),j(Na.$$.fragment,a),j(Ss.$$.fragment,a),j(Ma.$$.fragment,a),j(Is.$$.fragment,a),j(Ua.$$.fragment,a),j(Ms.$$.fragment,a),j(Ra.$$.fragment,a),j(Ga.$$.fragment,a),j(Rs.$$.fragment,a),j(Va.$$.fragment,a),j(Gs.$$.fragment,a),j(Ya.$$.fragment,a),j(Vs.$$.fragment,a),j(Ba.$$.fragment,a),j(Ws.$$.fragment,a),j(Ja.$$.fragment,a),fi=!0)},o(a){y(t.$$.fragment,a),y(ir.$$.fragment,a),y(bt.$$.fragment,a),y(jt.$$.fragment,a),y(mr.$$.fragment,a),y(hr.$$.fragment,a),y(gr.$$.fragment,a),y(fr.$$.fragment,a),y(ur.$$.fragment,a),y(_r.$$.fragment,a),y($r.$$.fragment,a),y(vr.$$.fragment,a),y(br.$$.fragment,a),y(wr.$$.fragment,a),y(jr.$$.fragment,a),y(yr.$$.fragment,a),y(kr.$$.fragment,a),y(Ar.$$.fragment,a),y(Er.$$.fragment,a),y(xr.$$.fragment,a),y(Pr.$$.fragment,a),y(Dr.$$.fragment,a),y(Tr.$$.fragment,a),y(zr.$$.fragment,a),y(Or.$$.fragment,a),y(Cr.$$.fragment,a),y(qr.$$.fragment,a),y(ea.$$.fragment,a),y(Lr.$$.fragment,a),y(ta.$$.fragment,a),y(Sr.$$.fragment,a),y(aa.$$.fragment,a),y(Nr.$$.fragment,a),y(ra.$$.fragment,a),y(Ur.$$.fragment,a),y(sa.$$.fragment,a),y(Gr.$$.fragment,a),y(oa.$$.fragment,a),y(Wr.$$.fragment,a),y(ca.$$.fragment,a),y(Fr.$$.fragment,a),y(la.$$.fragment,a),y(Hr.$$.fragment,a),y(na.$$.fragment,a),y(Br.$$.fragment,a),y(pa.$$.fragment,a),y(Kr.$$.fragment,a),y(ia.$$.fragment,a),y(Xr.$$.fragment,a),y(da.$$.fragment,a),y(Zr.$$.fragment,a),y(ma.$$.fragment,a),y(ts.$$.fragment,a),y(ha.$$.fragment,a),y(ga.$$.fragment,a),y(fa.$$.fragment,a),y(rs.$$.fragment,a),y(ua.$$.fragment,a),y(_a.$$.fragment,a),y(ss.$$.fragment,a),y($a.$$.fragment,a),y(os.$$.fragment,a),y(va.$$.fragment,a),y(cs.$$.fragment,a),y(ba.$$.fragment,a),y(ls.$$.fragment,a),y(wa.$$.fragment,a),y(is.$$.fragment,a),y(ja.$$.fragment,a),y(ms.$$.fragment,a),y(ya.$$.fragment,a),y(gs.$$.fragment,a),y(ka.$$.fragment,a),y(us.$$.fragment,a),y(Aa.$$.fragment,a),y($s.$$.fragment,a),y(Ea.$$.fragment,a),y(bs.$$.fragment,a),y(xa.$$.fragment,a),y(ws.$$.fragment,a),y(Pa.$$.fragment,a),y(Da.$$.fragment,a),y(ys.$$.fragment,a),y(Ta.$$.fragment,a),y(As.$$.fragment,a),y(za.$$.fragment,a),y(xs.$$.fragment,a),y(Oa.$$.fragment,a),y(Ds.$$.fragment,a),y(Ca.$$.fragment,a),y(zs.$$.fragment,a),y(qa.$$.fragment,a),y(Cs.$$.fragment,a),y(La.$$.fragment,a),y(qs.$$.fragment,a),y(Sa.$$.fragment,a),y(Ia.$$.fragment,a),y(Ls.$$.fragment,a),y(Na.$$.fragment,a),y(Ss.$$.fragment,a),y(Ma.$$.fragment,a),y(Is.$$.fragment,a),y(Ua.$$.fragment,a),y(Ms.$$.fragment,a),y(Ra.$$.fragment,a),y(Ga.$$.fragment,a),y(Rs.$$.fragment,a),y(Va.$$.fragment,a),y(Gs.$$.fragment,a),y(Ya.$$.fragment,a),y(Vs.$$.fragment,a),y(Ba.$$.fragment,a),y(Ws.$$.fragment,a),y(Ja.$$.fragment,a),fi=!1},d(a){r(c),a&&r(u),a&&r(m),k(t),a&&r($t),a&&r(J),a&&r(pr),a&&r(Ye),k(ir),a&&r(Tp),a&&r(so),a&&r(zp),a&&r(he),a&&r(Op),k(bt,a),a&&r(Cp),a&&r(Je),a&&r(qp),k(jt,a),a&&r(Lp),a&&r(yt),a&&r(Sp),a&&r(Ke),k(mr),a&&r(Ip),a&&r(Qe),k(hr),a&&r(Np),a&&r(Xe),a&&r(Mp),k(gr,a),a&&r(Up),a&&r(Ze),k(fr),a&&r(Rp),a&&r(et),k(ur),a&&r(Gp),a&&r(Pt),a&&r(Vp),k(_r,a),a&&r(Wp),a&&r(Dt),a&&r(Fp),k($r,a),a&&r(Hp),a&&r(tt),k(vr),a&&r(Yp),a&&r(zt),a&&r(Bp),k(br,a),a&&r(Jp),a&&r(Ot),a&&r(Kp),k(wr,a),a&&r(Qp),a&&r(at),k(jr),a&&r(Xp),a&&r(ho),a&&r(Zp),k(yr,a),a&&r(ei),k(kr,a),a&&r(ti),a&&r(rt),k(Ar),a&&r(ai),a&&r(Lt),a&&r(ri),a&&r(st),k(Er),a&&r(si),a&&r(It),a&&r(oi),k(xr,a),a&&r(ci),a&&r(ge),a&&r(li),k(Pr,a),a&&r(ni),a&&r(ot),k(Dr),a&&r(pi),a&&r(Y),a&&r(ii),a&&r(ct),k(Tr),a&&r(di),a&&r(Gt),a&&r(mi),k(zr,a),a&&r(hi),a&&r(lt),k(Or),a&&r(gi),a&&r(x),k(Cr),k(qr),k(ea),k(Lr),k(ta),k(Sr),k(aa),k(Nr),k(ra),k(Ur),k(sa),k(Gr),k(oa),k(Wr),k(ca),k(Fr),k(la),k(Hr),k(na),k(Br),k(pa),k(Kr),k(ia),k(Xr),k(da),k(Zr),k(ma),k(ts),k(ha),k(ga),k(fa),k(rs),k(ua),k(_a),k(ss),k($a),k(os),k(va),k(cs),k(ba),k(ls),k(wa),k(is),k(ja),k(ms),k(ya),k(gs),k(ka),k(us),k(Aa),k($s),k(Ea),k(bs),k(xa),k(ws),k(Pa),k(Da),k(ys),k(Ta),k(As),k(za),k(xs),k(Oa),k(Ds),k(Ca),k(zs),k(qa),k(Cs),k(La),k(qs),k(Sa),k(Ia),k(Ls),k(Na),k(Ss),k(Ma),k(Is),k(Ua),k(Ms),k(Ra),k(Ga),k(Rs),k(Va),k(Gs),k(Ya),k(Vs),k(Ba),k(Ws),k(Ja)}}}const Iw={local:"accelerator",sections:[{local:"quick-adaptation-of-your-code",title:"Quick adaptation of your code"},{local:"advanced-recommendations",sections:[{local:"printing",title:"Printing"},{local:"executing-processes",sections:[{local:"once-on-a-single-server",title:"Once on a single server"},{local:"only-ever-once-across-all-servers",title:"Only ever once across all servers"},{local:"on-specific-processes",title:"On specific processes"}],title:"Executing processes"},{local:"synchronicity-control",title:"Synchronicity control"},{local:"saving-and-loading",title:"Saving and loading"},{local:"operations",title:"Operations"},{local:"gradient-accumulation",title:"Gradient Accumulation"}],title:"Advanced recommendations"},{local:"accelerate.Accelerator",title:"Overall API documentation:"}],title:"Accelerator"};function Nw(E){return U2(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fw extends S2{constructor(c){super();I2(this,c,Nw,Sw,N2,{})}}export{Fw as default,Iw as metadata};
